#source etile_transceiver_status_tab.tcl

global BASE_ETILE_EHIPC3_100G
global BASE_ETILE_EHIPC3_100G_FEC
global BASE_ETILE_EHIPC3_100G_XCVR_LO
global BASE_ETILE_EHIPC3_100G_XCVR_L1
global BASE_ETILE_EHIPC3_100G_XCVR_L2
global BASE_ETILE_EHIPC3_100G_XCVR_L3
global BASE_PKT_CNTRL
set BASE_ETILE_EHIPC3_100G 0x0
set BASE_ETILE_EHIPC3_100G_FEC 0x10000
set BASE_ETILE_EHIPC3_100G_XCVR_LO 0x100000
set BASE_ETILE_EHIPC3_100G_XCVR_L1 0x200000
set BASE_ETILE_EHIPC3_100G_XCVR_L2 0x300000
set BASE_ETILE_EHIPC3_100G_XCVR_L3 0x400000
set BASE_PKT_CNTRL 0x1000

global freeze1
global freeze2
global freeze3
global freeze4
global freeze5
global freeze6
global freeze7

global textbox_freeze1
global textbox_freeze2
global textbox_freeze3
global textbox_freeze4
global textbox_freeze5
global textbox_freeze6
global textbox_freeze7

global corrected_cw0 
global uncorrected_cw0
global corrected_symbol0 
global corrected_bits_0_to_1_lane0 
global corrected_bits_1_to_0_lane0 
global corrected_symbols
global rate
global pattern
global master_claim_path
global ADDR_KR4_BASECTRL
global ADDR_KR4_BASESTAT
global freeze1


	set corrected_symbol0 "---"
	set corrected_bits_0_to_1_lane0 "---"
	set corrected_bits_1_to_0_lane0 "---"

set corrected_symbols 0
set corrected_cw0 "---"
set uncorrected_cw0 "---"
set ADDR_KR4_BASECTRL    0xb0
set ADDR_KR4_BASESTAT    0xb1		

proc reg_rmw {addr offset mask val} {
    set value [reg_read $addr $offset]
    set value [expr $value & [expr 0xffffffff & ~$mask]] 
    set value [expr $value | $val] 
    reg_write $addr $offset $value
}

proc stats_read {base loffset} {
    set hoffset [ expr $loffset + 1 ]

    set low_data [ reg_read $base $loffset ]
    set hi_data  [ reg_read $base $hoffset ]
    set data [ expr { ($hi_data << 32) + $low_data } ]
    return $data
}

proc proc_continuous_read_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
	
	global rs_enabled
	global pma_cont_enabled
	global anlt_enabled
	global dash_xcvr_debug_tool_kit version
	
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]	
	dashboard_set_property $dash1 etile_read enabled false
	dashboard_set_property $dash1 etile_pma_continuous_read enabled false
	freeze_buttons
		while {[string match [dashboard_get_property $dash continuous_read_etile_ehipc3_100g checked] "true"]} {
			#puts {Continuosly Reading}
			proc_read_pcs_status_etile_ehipc3_100g
			proc_read_txmac_status_etile_ehipc3_100g
			proc_read_rxmac_status_etile_ehipc3_100g
			proc_read_tx_stats_etile_ehipc3_100g
			proc_read_rx_stats_etile_ehipc3_100g
			if {$rs_enabled == 1} {
				proc_read_fec_stats
			}
			
			if {$pma_cont_enabled == 1} {
				cont_eli_read_all_phy
			}
			
			if {$anlt_enabled == 1} {
				proc_read_kr4_status				
			}
		}
	dashboard_set_property $dash1 etile_read enabled true
	dashboard_set_property $dash1 etile_pma_continuous_read enabled true
	unfreeze_buttons
}

proc proc_eio_sys_rst_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
	global ip_sub_variant_option
	global ical_recipe_option
	
		if {[string match [dashboard_get_property $dash eio_sys_rst_etile_ehipc3_100g text] "Assert Full System Reset"]} {
		puts "Reseting TX & RX - MAC PCS PMA"
		dashboard_set_property $dash eio_sys_rst_etile_ehipc3_100g text "Deassert Full System Reset"
		reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x1
			set_pma_reset 0
		dashboard_set_property $dash ical_recipe_dropdown selectedItem "Default"
		set ical_recipe_option "def"
		dashboard_set_property $dash ical_recipe_apply enabled false			
		} elseif {[string match [dashboard_get_property $dash eio_sys_rst_etile_ehipc3_100g text] "Deassert Full System Reset"]} {
		
		reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x0
		dashboard_set_property $dash eio_sys_rst_etile_ehipc3_100g text "Assert Full System Reset"
		}
		after 10
}

proc proc_soft_txp_rst_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
		
		if {[string match [dashboard_get_property $dash soft_txp_rst_etile_ehipc3_100g text] "Assert TX MAC & PCS Reset"]} {
		puts "Reseting TX MAC & PCS"
		reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x2
		dashboard_set_property $dash soft_txp_rst_etile_ehipc3_100g text "Deassert TX MAC & PCS Reset"
		} elseif {[string match [dashboard_get_property $dash soft_txp_rst_etile_ehipc3_100g text] "Deassert TX MAC & PCS Reset"]} {
		
		reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x0
		dashboard_set_property $dash soft_txp_rst_etile_ehipc3_100g text "Assert TX MAC & PCS Reset"
		}
		after 10
}

proc proc_soft_rxp_rst_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
		
		if {[string match [dashboard_get_property $dash soft_rxp_rst_etile_ehipc3_100g text] "Assert RX MAC & PCS Reset"]} {
		puts "Reseting RX MAC & PCS"
		reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x4
		dashboard_set_property $dash soft_rxp_rst_etile_ehipc3_100g text "Deassert RX MAC & PCS Reset"
		} elseif {[string match [dashboard_get_property $dash soft_rxp_rst_etile_ehipc3_100g text] "Deassert RX MAC & PCS Reset"]} {
		
		reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x0
		dashboard_set_property $dash soft_rxp_rst_etile_ehipc3_100g text "Assert RX MAC & PCS Reset"
		}
		after 10
}

proc proc_read_pcs_status_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
	global BASE_ETILE_EHIPC3_100G_FEC
	
	global ip_sub_variant_option
	global rs_enabled	
	
	#puts "Reading PCS Status"
	
	set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x342]
	dashboard_set_property $dash txclk_value_etile_ehipc3_100g text [format %u [expr $pcs_status_value_etile_ehipc3_100g * 10]]
	
	
	set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x322]
	if {[expr $pcs_status_value_etile_ehipc3_100g & 0x00000001]} {
		dashboard_set_property $dash txpcsready_value_etile_ehipc3_100g color green
        } else {
        dashboard_set_property $dash txpcsready_value_etile_ehipc3_100g color red
        }
	
	
	set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x341]
	dashboard_set_property $dash rxclk_value_etile_ehipc3_100g text [format %u [expr $pcs_status_value_etile_ehipc3_100g * 10]]
	
	
	# set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x323]
	# dashboard_set_property $dash frameerror_value_etile_ehipc3_100g text "$pcs_status_value_etile_ehipc3_100g"
	
	
	#set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x328]
	#if {[expr $pcs_status_value_etile_ehipc3_100g & 0x00000001]} {
	#	dashboard_set_property $dash amlock_value_etile_ehipc3_100g color green
    #   } else {
    #    dashboard_set_property $dash amlock_value_etile_ehipc3_100g color red
    #    }
	
	
	# set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x32A]
	# dashboard_set_property $dash bercount_value_etile_ehipc3_100g text "$pcs_status_value_etile_ehipc3_100g"
	
	
	set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x326]
	if {[expr $pcs_status_value_etile_ehipc3_100g & 0x00000002]} {
		dashboard_set_property $dash hiber_value_etile_ehipc3_100g text "Detected"
        } else {
        dashboard_set_property $dash hiber_value_etile_ehipc3_100g text "Not Detected"
        }
	
		

	set pcs_status_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x326]
	if {[expr $pcs_status_value_etile_ehipc3_100g & 0x00000001]} {
		dashboard_set_property $dash rxpcsaligned_value_etile_ehipc3_100g color green
        } else {
        dashboard_set_property $dash rxpcsaligned_value_etile_ehipc3_100g color red
        }
			
	set pcs_status_value_etile_ehipc3_100g [reg_read 0X0320]
	    if {[expr $pcs_status_value_etile_ehipc3_100g & 0x00000001]} {
             dashboard_set_property $dash txlocked_l0_etile_ehipc3_100g color green
           } else {
             dashboard_set_property $dash txlocked_l0_etile_ehipc3_100g color red
           }
		  
		
		
	
	set pcs_status_value_etile_ehipc3_100g [reg_read 0X0321]
	    if {[expr $pcs_status_value_etile_ehipc3_100g & 0x00000001]} {
             dashboard_set_property $dash rxcdrplllocked_l0_etile_ehipc3_100g color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l0_etile_ehipc3_100g color red
           }
		
	    
		
}

proc proc_read_kr4_status {} {

	global dash

	global BASE_ETILE_EHIPC3_100G

	set reg_0xC0 [reg_read $BASE_ETILE_EHIPC3_100G 0xC0]
	
		if {[expr $reg_0xC0 & 0x00000001]} {
		dashboard_set_property $dash an_ena_data color green
        } else {
        dashboard_set_property $dash an_ena_data color red
        }
		
	set reg_0xC2 [reg_read $BASE_ETILE_EHIPC3_100G 0xC2]
	
		if {[expr $reg_0xC2 & 0x00000002]} {
		dashboard_set_property $dash an_page_received_data color green
        } else {
        dashboard_set_property $dash an_page_received_data color red
        }
		
		if {[expr $reg_0xC2 & 0x00000004]} {
		dashboard_set_property $dash an_complete_data color green
        } else {
        dashboard_set_property $dash an_complete_data color red
        }
		
		if {[expr $reg_0xC2 & 0x00000080]} {
		dashboard_set_property $dash an_abi_data text "Able to perform AN"
        } else {
        dashboard_set_property $dash an_abi_data text "Unable to perform AN"
        }
		
		if {[expr $reg_0xC2 & 0x00001000]} {
        dashboard_set_property $dash an_ieee_data text "1000BASE-KX"
        } elseif {[expr $reg_0xC2 & 0x00002000]} {
        dashboard_set_property $dash an_ieee_data text "10GBASE-KX4"
        } elseif {[expr $reg_0xC2 & 0x00004000]} {
        dashboard_set_property $dash an_ieee_data text "10GBASE-KR"
        } elseif {[expr $reg_0xC2 & 0x00008000]} {
        dashboard_set_property $dash an_ieee_data text "40GBASE-KR4"
        } elseif {[expr $reg_0xC2 & 0x00010000]} {
        dashboard_set_property $dash an_ieee_data text "40GBASE-CR4"
		} elseif {[expr $reg_0xC2 & 0x00020000]} {
        dashboard_set_property $dash an_ieee_data text "100GBASE-CR10"
		} elseif {[expr $reg_0xC2 & 0x00040000]} {
        dashboard_set_property $dash an_ieee_data text "100GBASE-KP4"
		} elseif {[expr $reg_0xC2 & 0x00080000]} {
        dashboard_set_property $dash an_ieee_data text "100GBASE-KR4"
		} elseif {[expr $reg_0xC2 & 0x00100000]} {
        dashboard_set_property $dash an_ieee_data text "100GBASE-CR4"
		} elseif {[expr $reg_0xC2 & 0x00200000]} {
        dashboard_set_property $dash an_ieee_data text "25GBASE-KR-S/CR-S"
		} elseif {[expr $reg_0xC2 & 0x00400000]} {
        dashboard_set_property $dash an_ieee_data text "25GBASE-KR/CR"
		} elseif {[expr $reg_0xC2 & 0x00800000]} {
        dashboard_set_property $dash an_ieee_data text "100GBASE-KR2/CR2"
		} else {
		dashboard_set_property $dash an_ieee_data text "--"
		}
		
		if {[expr $reg_0xC2 & 0x01000000]} {
		dashboard_set_property $dash an_consortium_port_type_data text "25GBASE-KR1"
        } elseif {[expr $reg_0xC2 & 0x02000000]} {                 
        dashboard_set_property $dash an_consortium_port_type_data text  "25GBASE-CR1"
        } elseif {[expr $reg_0xC2 & 0x04000000]} {                
        dashboard_set_property $dash an_consortium_port_type_data text  "50GBASE-KR2"
		} elseif {[expr $reg_0xC2 & 0x08000000]} {                
        dashboard_set_property $dash an_consortium_port_type_data text  "50GBASE-CR2"
		} else {
		dashboard_set_property $dash an_consortium_port_type_data text  "--"
		}
		
		# if {[expr $reg_0xC2 & 0x40000000]} {
		# dashboard_set_property $dash an_rs_fec_neg_data text "RSFEC was negotiated"
        # } else {
        # dashboard_set_property $dash an_rs_fec_neg_data text "Link will not use RSFEC"
        # }
		
	 
	set reg_0xCB [reg_read $BASE_ETILE_EHIPC3_100G 0xCB]
	
		dict set MAIN_DICT lp_tech ""
		dict set MAIN_DICT AN_tech_map.0 "xxx"
		dict set MAIN_DICT AN_tech_map.1 "1000BASE-KX"
		dict set MAIN_DICT AN_tech_map.2 "10GBASE-KX4"
		dict set MAIN_DICT AN_tech_map.3 "10GBASE-KR"
		dict set MAIN_DICT AN_tech_map.4 "40GBASE-KR4"
		dict set MAIN_DICT AN_tech_map.5 "40GBASE-CR4"
		dict set MAIN_DICT AN_tech_map.6 "100GBASE-CR10"
		dict set MAIN_DICT AN_tech_map.7 "100GBASE-KP4"
		dict set MAIN_DICT AN_tech_map.8 "100GBASE-KR4"
		dict set MAIN_DICT AN_tech_map.9 "100GBASE-CR4"
		dict set MAIN_DICT AN_tech_map.10 "25GBASE-KR-S"
		dict set MAIN_DICT AN_tech_map.11 "25GBASE-KR"

		set new_lp_tech [reg_read $BASE_ETILE_EHIPC3_100G 0xCB]

		for {set m 0} {$m < 11} {incr m} {
						set temp_new_lp_tech [expr {[expr {$new_lp_tech & [expr {2**$m}]}] >> $m }]                                                                                                                  
						if {$temp_new_lp_tech == 1} {
										dict append MAIN_DICT lp_tech "[dict get $MAIN_DICT AN_tech_map.[expr {$m+1}]]\n"
						}
		}
		dashboard_set_property $dash an_link_partner_data text [dict get $MAIN_DICT lp_tech] 
			
				
		if {[expr $reg_0xCB & 0x00800000]} {
        dashboard_set_property $dash an_link_partner_fec_data text "25G RS-FEC Requested"
		} elseif {[expr $reg_0xCB & 0x01000000]} {
        dashboard_set_property $dash an_link_partner_fec_data text "25G Bae-R FEC (CL 74 Firecode) Requested"
		} elseif {[expr $reg_0xCB & 0x02000000]} {
        dashboard_set_property $dash an_link_partner_fec_data text "FEC Ability"
		} elseif {[expr $reg_0xCB & 0x0400000]} {
        dashboard_set_property $dash an_link_partner_fec_data text "FEC Requested"
		} else {
		dashboard_set_property $dash an_link_partner_fec_data text "--"
		} 
		
		
		if {[expr $reg_0xCB & 0x08000000]} {
		dashboard_set_property $dash an_link_partner_remote_data text "Fault Detected"
		dashboard_set_property $dash an_link_partner_remote_title foregroundColor red
        } else {
        dashboard_set_property $dash an_link_partner_remote_data text "Fault Not Detected"
		dashboard_set_property $dash an_link_partner_remote_title foregroundColor black
        }
		
		if {[expr $reg_0xCB & 0x10000000]} {
		dashboard_set_property $dash an_link_partner_pause_data text "Pause"
        } else {
        dashboard_set_property $dash an_link_partner_pause_data text "ASM_DIR"
        }
		
	set reg_0xD0 [reg_read $BASE_ETILE_EHIPC3_100G 0xD0]
		
		if {[expr $reg_0xD0 & 0x00000001]} {
		dashboard_set_property $dash lt_ena_data color green
        } else {
        dashboard_set_property $dash lt_ena_data color red
        }
		
	set reg_0xD2 [reg_read $BASE_ETILE_EHIPC3_100G 0xD2]	
		
		if {[expr $reg_0xD2 & 0x00000001]} {
		dashboard_set_property $dash lt_receiver_trained_data color green
        } else {
        dashboard_set_property $dash lt_receiver_trained_data color red
        }
		
		# if {[expr $reg_0xD2 & 0x00000002]} {
		# dashboard_set_property $dash lt_training_frame_data color green
        # } else {
        # dashboard_set_property $dash lt_training_frame_data color red
        # }
		
	set reg_0xB1 [reg_read $BASE_ETILE_EHIPC3_100G 0xB1]	
		
		if {[expr $reg_0xB1 & 0x00000001]} {
		dashboard_set_property $dash seq_link_ready_data color green
        } else {
        dashboard_set_property $dash seq_link_ready_data color red
        }
		
		if {[expr $reg_0xB1 & 0x00000100]} {
		dashboard_set_property $dash seq_reconfig_data text "AN Mode"
        } elseif {[expr $reg_0xB1 & 0x00000200]} {
        dashboard_set_property $dash seq_reconfig_data text "LT Mode"
        } elseif {[expr $reg_0xB1 & 0x00000400]} {
        dashboard_set_property $dash seq_reconfig_data text "10G Data mode"
		} elseif {[expr $reg_0xB1 & 0x00000800]} {
        dashboard_set_property $dash seq_reconfig_data text "25G Data mode"
		} elseif {[expr $reg_0xB1 & 0x00001000]} {
        dashboard_set_property $dash seq_reconfig_data text "50G-R2 Data mode"
		} elseif {[expr $reg_0xB1 & 0x00002000]} {
        dashboard_set_property $dash seq_reconfig_data text "100G-R4 Data mode"
		} elseif {[expr $reg_0xB1 & 0x00004000]} {
        dashboard_set_property $dash seq_reconfig_data text "40G-R4 Data mode"
		} elseif {[expr $reg_0xB1 & 0x00008000]} {
        dashboard_set_property $dash seq_reconfig_data text "100G-P2 Data mode"
		} else {
		dashboard_set_property $dash seq_reconfig_data text "--"
		}
		
	set reg_0xB0 [reg_read	$BASE_ETILE_EHIPC3_100G 0xB0]
		if {[expr $reg_0xB0 & 0x00100000]} {
			dashboard_set_property $dash fec_negotitation_rsfec checked true
		} else {
			dashboard_set_property $dash fec_negotitation_rsfec checked false
		}	
		
		if {[expr $reg_0xB0 & 0x00200000]} {
			dashboard_set_property $dash fec_request_rsfec checked true
		} else {
			dashboard_set_property $dash fec_request_rsfec checked false
		}	
		

}

proc proc_seq_force {} {
	
	global dash
	global BASE_ETILE_EHIPC3_100G
	
	if {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "No Force"]} {
		#enable AN
		reg_rmw 0xC0 $BASE_ETILE_EHIPC3_100G 0x1 0x1
		#enable LT
		reg_rmw 0xD0 $BASE_ETILE_EHIPC3_100G 0x1 0x1
		#reset KR sequencer
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x1 0x1
		
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x70 0x00
			
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "10GBase-R"]} {
		#set val 0x21 (maybe 0x31)
		#reconfig_reg_rmw 0 0x00B0 $BASE_LL100G 0x000000f1 0x31
		
		# #disable AN
		reg_rmw 0xC0 $BASE_ETILE_EHIPC3_100G 0x1 0x0
		# #disable LT
		reg_rmw 0xD0 $BASE_ETILE_EHIPC3_100G 0x1 0x0
		# #reset KR sequencer
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x1 0x1
		
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x70 0x50
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "25GBase-R"]} {
		#set val 0x21 (maybe 0x31)
		#reconfig_reg_rmw 0 0x00B0 $BASE_LL100G 0x000000f1 0x31
	
		# #disable AN
		reg_rmw 0xC0 $BASE_ETILE_EHIPC3_100G 0x1 0x0
		# #disable LT
		reg_rmw 0xD0 $BASE_ETILE_EHIPC3_100G 0x1 0x0
		# #reset KR sequencer
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x1 0x1
		
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x70 0x10
	}
}

proc proc_reset_seq {} {
	
	global BASE_ETILE_EHIPC3_100G
	global dash
	
	reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0xff 0x7
	dashboard_set_property $dash ilb_lpbk_etile_ehipc3_100g checked false
}

proc proc_disable_if_timer {} {
	
	global dash
	global BASE_ETILE_EHIPC3_100G
	
	if { [dashboard_get_property $dash disable_if_timer checked] } {
		
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x4 0x4
		
	} else {
	
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x4 0x0
	}
}

proc proc_ignore_nonce {} {

	global dash
	global BASE_ETILE_EHIPC3_100G
	
	if { [dashboard_get_property $dash ignore_nonce checked] } {
		
		reg_write $BASE_ETILE_EHIPC3_100G 0xD0 0x000e4a81
		reg_rmw 0xC0 $BASE_ETILE_EHIPC3_100G 0x80 0x80
		
	} else {
		
		reg_write $BASE_ETILE_EHIPC3_100G 0xD0 0x00004a81
		reg_rmw 0xC0 $BASE_ETILE_EHIPC3_100G 0x80 0x00
	}

}

proc proc_disable_max_timer {} {

	global dash
	global BASE_ETILE_EHIPC3_100G
	
	if { [dashboard_get_property $dash lt_disable_max_timer checked] } {
		
		reg_rmw 0xD0 $BASE_ETILE_EHIPC3_100G 0x2 0x2
		
	} else {
	
		reg_rmw 0xD0 $BASE_ETILE_EHIPC3_100G 0x2 0x0
	}

}

proc proc_request_rsfec {} {

	global dash
	global BASE_ETILE_EHIPC3_100G
	
	if { [dashboard_get_property $dash fec_request_rsfec checked] } {
		
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x200000 0x200000
		
	} else {
	
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x200000 0x000000
	}

}

proc proc_rsfec_negotiate {} {

	global dash
	global BASE_ETILE_EHIPC3_100G
	
	if { [dashboard_get_property $dash fec_negotitation_rsfec checked] } {
		
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x100000 0x100000
		
	} else {
	
		reg_rmw 0xB0 $BASE_ETILE_EHIPC3_100G 0x100000 0x000000
	}

}


proc kr_pause {} {
  global BASE_ETILE_EHIPC3_100G
  global ADDR_KR4_BASECTRL
  global ADDR_KR4_BASESTAT
  set reg [reg_read   $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASECTRL]
  reg_write $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASECTRL [expr $reg | 0x80000000]
  #bail if register write didn't work (probably no AN/LT in design, or in reset)
  if {!([reg_read   $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASECTRL] & 0x80000000)} {return}
  #otherwise, wait for acknowledge
  while {!([reg_read $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASESTAT] & 0x80000000)} {}
}

proc kr_unpause {} {
  global BASE_ETILE_EHIPC3_100G
  global ADDR_KR4_BASECTRL
  global ADDR_KR4_BASESTAT
  set reg [reg_read   $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASECTRL]
  reg_write $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASECTRL [expr $reg & 0x7FFFFFFF]
  while {[reg_read $BASE_ETILE_EHIPC3_100G $ADDR_KR4_BASESTAT] & 0x80000000} {}
}

proc pma_int {base num code data} {
	global anlt_enabled
	#kr_pause will stop the KR cpu from issuing ints, or noop if AN/LT is not enabled
    if {$anlt_enabled} {
    kr_pause
	}
	#load interrupt data
    reg_write $base 0x84 [expr $data & 0xff]
    reg_write $base 0x85 [expr $data >> 8]
    reg_write $base 0x86 $num
    reg_write $base 0x87 $code
    #trigger interrupt
    reg_write $base 0x90 1
	
	
	#wait for transaction bit
    while {![expr [reg_read $base 0x8A] & 0x80]} {}
	
	
    #wait for interrupt to finish
    while {[expr [reg_read $base 0x8B] & 0x01]} {}
	
	
    #read out data
    set rdata [expr [reg_read $base 0x88] | ([reg_read $base 0x89] << 8)]
	
    #clear transaction bit (write 1 to clear)
    reg_write $base 0x8A 0x80
	
	if {$anlt_enabled} {
	kr_unpause
	}
	
    return 0x[format %0x $rdata]	
}

proc s10e_pma_request {base_addr interrupt_code interrupt_data } {
 
 reg_write [expr $base_addr + 0x84] [expr $interrupt_data & 0xff]
 reg_write [expr $base_addr + 0x85] [expr $interrupt_data>>8 & 0xff]
 reg_write [expr $base_addr + 0x86] [expr $interrupt_code & 0xff]
 reg_write [expr $base_addr + 0x87] [expr $interrupt_code>>8 & 0xff]
 reg_write [expr $base_addr + 0x90] 0x1
 after 100
 set value [reg_read [expr $base_addr + 0x8b] 1]
 set value [expr $value & [expr 0x01]] 
 
 
}



proc proc_ilb_lpbk_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
	global BASE_ETILE_EHIPC3_100G_XCVR_LO
	global BASE_ETILE_EHIPC3_100G_XCVR_L1
	global BASE_ETILE_EHIPC3_100G_XCVR_L2
	global BASE_ETILE_EHIPC3_100G_XCVR_L3
	
	global ip_sub_variant_option	
	
	if {$ip_sub_variant_option == "25g_nrz"} {	
		if {[string match [dashboard_get_property $dash ilb_lpbk_etile_ehipc3_100g checked] "true"]} {	
			
			
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 1]
			
			
		} else {
			
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 0]	
			
		}
	} elseif {$ip_sub_variant_option == "10g_nrz"} {	
		if {[string match [dashboard_get_property $dash ilb_lpbk_etile_ehipc3_100g checked] "true"]} {	
			
			
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 1]
			
		} else {
		
			
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 0]	
			
			
		}	
	
	
	}	
		
	
	# if {$ip_sub_variant_option == "100g_pam4"} {		
			# if {[string match [dashboard_get_property $dash ilb_lpbk_etile_ehipc3_100g checked] "true"]} {	
				# #ILB
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 1]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L2 0x08 0x00 [expr 0x0100 | 1]
				
			# } else {		
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 0]				
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L2 0x08 0x00 [expr 0x0100 | 0]
				
			# }
	# } else {
			# puts "NRZ"
			# if {[string match [dashboard_get_property $dash ilb_lpbk_etile_ehipc3_100g checked] "true"]} {	
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 1]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L1 0x08 0x00 [expr 0x0100 | 1]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L2 0x08 0x00 [expr 0x0100 | 1]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L3 0x08 0x00 [expr 0x0100 | 1]
			# } else {
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 0]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L1 0x08 0x00 [expr 0x0100 | 0]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L2 0x08 0x00 [expr 0x0100 | 0]
				# pma_int $BASE_ETILE_EHIPC3_100G_XCVR_L3 0x08 0x00 [expr 0x0100 | 0]
			# }
	# }	
			
}

proc proc_iadp_lpbk_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
	global BASE_ETILE_EHIPC3_100G_XCVR_LO
	global BASE_ETILE_EHIPC3_100G_XCVR_L1
	global BASE_ETILE_EHIPC3_100G_XCVR_L2
	global BASE_ETILE_EHIPC3_100G_XCVR_L3
	global anlt_enabled
	
	global ip_sub_variant_option	
	

	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color yellow
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP Processing..."
	freeze_buttons
	dashboard_set_property $dash continuous_read_etile_ehipc3_100g enabled false
	set iadp_done 0
	if {$ip_sub_variant_option == "25g_nrz"} {		
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x0a 0x00 0x0001
			
			s10e_pma_request 0x100000 0x126 0xb00
			set val1 [reg_read [expr 0x100000 + 0x88]]
			set val1 [expr $val1 & 0x01]
			puts "iADP Processing..."
			set iadp_time 0
			while {$val1} {
				s10e_pma_request 0x100000 0x126 0xb00
				set val1 [reg_read [expr 0x100000 + 0x88]]
				set val1 [expr $val1 & 0x01]
				incr iadp_time
				if {$iadp_time > 150} {
					puts "iADP Time out"
					set iadp_done 1
					break
				}	
				after 100
			}
			
			
			
	} else {	
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x0a 0x00 0x0001
			
			s10e_pma_request 0x100000 0x126 0xb00
			set val1 [reg_read [expr 0x100000 + 0x88]]
			set val1 [expr $val1 & 0x01]
			puts "iADP Processing..."
			set iadp_time 0
			while {$val1} {
				s10e_pma_request 0x100000 0x126 0xb00
				set val1 [reg_read [expr 0x100000 + 0x88]]
				set val1 [expr $val1 & 0x01]
				incr iadp_time
				if {$iadp_time > 150} {
					puts "iADP Time out"
					set iadp_done 1
					break
				}	
				after 100
			}
		
		
	} 
	
	if {$iadp_done} {
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color red
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP 15 sec Time-out. Try again"
	} else {
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color green
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP Done"	
	puts "iADP Done"
	}
	unfreeze_buttons
	dashboard_set_property $dash continuous_read_etile_ehipc3_100g enabled true
	after 1000	
	proc_read_pcs_status_etile_ehipc3_100g
	
	if {$anlt_enabled} {
		proc_read_kr4_status
		eli_read_all_phy
	}
		
}

proc proc_imiss_lpbk_etile_ehipc3_100g {} {
	global dash
	global BASE_ETILE_EHIPC3_100G
	global BASE_ETILE_EHIPC3_100G_XCVR_LO
	global BASE_ETILE_EHIPC3_100G_XCVR_L1
	global BASE_ETILE_EHIPC3_100G_XCVR_L2
	global BASE_ETILE_EHIPC3_100G_XCVR_L3
	
	global ip_sub_variant_option	
	
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color yellow
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP Processing..."
	freeze_buttons
	dashboard_set_property $dash continuous_read_etile_ehipc3_100g enabled false	
	set imiss_done1 0
	set imiss_done2 0
	if {$ip_sub_variant_option == "25g_nrz"} {
		#ILB
		pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 1]
		#IADP
		pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x0a 0x00 0x0001
		
		
		s10e_pma_request 0x100000 0x126 0xb00
		set val1 [reg_read [expr 0x100000 + 0x88]]
		set val1 [expr $val1 & 0x01]
		puts "processing..."
		set imiss_time1 0
		while {$val1} {
			s10e_pma_request 0x100000 0x126 0xb00
			set val1 [reg_read [expr 0x100000 + 0x88]]
			set val1 [expr $val1 & 0x01]
			
			#led
			incr imiss_time1
				
				if {$imiss_time1 > 150} {
					puts "Time out"
					set imiss_done1 1
					break
				}	
				after 100
		}
		
		#Mission_mode
		if {$imiss_done1 == 0} {
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 0]				
					
			#IADP
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x0a 0x00 0x0001
			
			
			s10e_pma_request 0x100000 0x126 0xb00
			set val1 [reg_read [expr 0x100000 + 0x88]]
			set val1 [expr $val1 & 0x01]
			
			set imiss_time2 0
			while {$val1} {
				s10e_pma_request 0x100000 0x126 0xb00
				set val1 [reg_read [expr 0x100000 + 0x88]]
				set val1 [expr $val1 & 0x01]
				
				#led
				incr imiss_time2
				
				if {$imiss_time2 > 150} {
					puts "Time out"
					set imiss_done2 1
					break
				}	
				after 100
			}
			
			
		} 
		
	} else {
		#ILB
		pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 1]
		#IADP
		pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x0a 0x00 0x0001
		
		
		s10e_pma_request 0x100000 0x126 0xb00
		set val1 [reg_read [expr 0x100000 + 0x88]]
		set val1 [expr $val1 & 0x01]
		puts "processing..."
		set imiss_time1 0
		while {$val1} {
			s10e_pma_request 0x100000 0x126 0xb00
			set val1 [reg_read [expr 0x100000 + 0x88]]
			set val1 [expr $val1 & 0x01]
			
			#led
			incr imiss_time1
				
				if {$imiss_time1 > 150} {
					puts "Time out"
					set imiss_done1 1
					break
				}	
				after 100
		}
		
		#Mission_mode
		if {$imiss_done1 == 0} {
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x08 0x00 [expr 0x0100 | 0]				
					
			#IADP
			pma_int $BASE_ETILE_EHIPC3_100G_XCVR_LO 0x0a 0x00 0x0001
			
			
			s10e_pma_request 0x100000 0x126 0xb00
			set val1 [reg_read [expr 0x100000 + 0x88]]
			set val1 [expr $val1 & 0x01]
			
			set imiss_time2 0
			while {$val1} {
				s10e_pma_request 0x100000 0x126 0xb00
				set val1 [reg_read [expr 0x100000 + 0x88]]
				set val1 [expr $val1 & 0x01]
				
				#led
				incr imiss_time2
				
				if {$imiss_time2 > 150} {
					puts "Time out"
					set imiss_done2 1
					break
				}	
				after 100
			}
			
			
		} 
	
	}
	if {$imiss_done1} {
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color red
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP 1 15 sec Time-out. Try again"
	} elseif {$imiss_done2} {
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color red
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP 2 15 sec Time-out. Try again"	
	} else {
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g color green
	dashboard_set_property $dash ical_notif_etile_ehipc3_100g text "iADP Done"	
	puts "Mission mode Done"
	}
	unfreeze_buttons
	dashboard_set_property $dash continuous_read_etile_ehipc3_100g enabled true
	dashboard_set_property $dash ilb_lpbk_etile_ehipc3_100g checked false
	after 1000	
	proc_read_pcs_status_etile_ehipc3_100g
	
}

proc proc_read_txmac_status_etile_ehipc3_100g {} {

global dash
global BASE_ETILE_EHIPC3_100G

#puts "Reading TX MAC Configuration"

	set txmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x405]
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000008]} {
			dashboard_set_property $dash force_remote_fault_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash force_remote_fault_text_etile_ehipc3_100g text "Off"
			
           }
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000004]} {
			dashboard_set_property $dash disable_remote_fault_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash disable_remote_fault_text_etile_ehipc3_100g text "Off"
           }
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000002]} {
			dashboard_set_property $dash unidir_remote_link_fault_reporting_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash unidir_remote_link_fault_reporting_text_etile_ehipc3_100g text "Off"
           }
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash link_fault_reporting_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash link_fault_reporting_text_etile_ehipc3_100g text "Off"
           }
		   
	set txmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x406]
		dashboard_set_property $dash idle_col_rem_text_etile_ehipc3_100g text "$txmac_value_etile_ehipc3_100g"
	
	set txmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x407]
		dashboard_set_property $dash max_tx_size_config_text_etile_ehipc3_100g text "$txmac_value_etile_ehipc3_100g"
	
	set txmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x40A]
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000004]} {
			dashboard_set_property $dash en_saddr_insert_text_etile_ehipc3_100g text "TX MAC inserts source address"
			} else {
			dashboard_set_property $dash en_saddr_insert_text_etile_ehipc3_100g text "Client provides Source Address"
           }
		   
	set txmac_value_etile_ehipc3_100g [reg_read 0x040D]
	dashboard_set_property $dash saddrh_text_etile_ehipc3_100g text "$txmac_value_etile_ehipc3_100g"

	set txmac_value_etile_ehipc3_100g [reg_read 0x040C]
	dashboard_set_property $dash saddrl_text_etile_ehipc3_100g text "$txmac_value_etile_ehipc3_100g"
	
	set txmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x40A]
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash vlan_detection_tx_text_etile_ehipc3_100g text "Disabled"
			} else {
			dashboard_set_property $dash vlan_detection_tx_text_etile_ehipc3_100g text "Enabled"
           }
		   
	set txmac_value_etile_ehipc3_100g [reg_read 0x040B]
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000200]} {
			dashboard_set_property $dash txcrc_covers_preamble_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash txcrc_covers_preamble_text_etile_ehipc3_100g text "Off"
           }
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000006]} {
			dashboard_set_property $dash ipg_text_etile_ehipc3_100g text "1 byte"
			} elseif {[expr $txmac_value_etile_ehipc3_100g & 0x00000004]} {
			dashboard_set_property $dash ipg_text_etile_ehipc3_100g text "4 bytes"
           } elseif {[expr $txmac_value_etile_ehipc3_100g & 0x00000002]} {
			dashboard_set_property $dash ipg_text_etile_ehipc3_100g text "8 bytes"
           } else {
		    dashboard_set_property $dash ipg_text_etile_ehipc3_100g text "12 bytes"
		   }
		if {[expr $txmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash en_pp_tx_text_etile_ehipc3_100g text "Enabled"
			} else {
			dashboard_set_property $dash en_pp_tx_text_etile_ehipc3_100g text "Disabled"
           }

}

proc proc_read_rxmac_status_etile_ehipc3_100g {} {

global dash
global BASE_ETILE_EHIPC3_100G

#puts "Reading RX MAC Configuration"

	set rxmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x506]
		dashboard_set_property $dash max_rx_size_config_text_etile_ehipc3_100g text "$rxmac_value_etile_ehipc3_100g"
		
	set rxmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x507]
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash mac_crc_config_text_etile_ehipc3_100g text "Forward CRC to RX Client"
			} else {
			dashboard_set_property $dash mac_crc_config_text_etile_ehipc3_100g text "Remove CRC from RX frames"
           }
		   
	set rxmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x508]
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000002]} {
			dashboard_set_property $dash remote_fault_text_etile_ehipc3_100g text "Detected"
			dashboard_set_property $dash remote_fault_etile_ehipc3_100g foregroundColor red
			} else {
			dashboard_set_property $dash remote_fault_text_etile_ehipc3_100g text "Not Detected"
			dashboard_set_property $dash remote_fault_etile_ehipc3_100g foregroundColor black
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash local_fault_text_etile_ehipc3_100g text "Detected"
			dashboard_set_property $dash local_fault_etile_ehipc3_100g foregroundColor red	
			} else {
			dashboard_set_property $dash local_fault_text_etile_ehipc3_100g text "Not Detected"
			dashboard_set_property $dash local_fault_etile_ehipc3_100g foregroundColor black
           }
		   
	set rxmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x50A]
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000100]} {
			dashboard_set_property $dash remove_rx_pad_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash remove_rx_pad_text_etile_ehipc3_100g text "Off"
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000080]} {
			dashboard_set_property $dash enforce_max_rx_text_etile_ehipc3_100g text "Frames are ended with FCS error"
			} else {
			dashboard_set_property $dash enforce_max_rx_text_etile_ehipc3_100g text "Ovesized frames are not altered"
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000010]} {
			dashboard_set_property $dash preamble_check_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash preamble_check_text_etile_ehipc3_100g text "Off"
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000008]} {
			dashboard_set_property $dash sfd_check_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash sfd_check_text_etile_ehipc3_100g text "Off"
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000002]} {
			dashboard_set_property $dash vlan_detection_rx_text_etile_ehipc3_100g text "Disabled"
			} else {
			dashboard_set_property $dash vlan_detection_rx_text_etile_ehipc3_100g text "Enabled"
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash en_plen_text_etile_ehipc3_100g text "On"
			} else {
			dashboard_set_property $dash en_plen_text_etile_ehipc3_100g text "Off"
           }
		   
	set rxmac_value_etile_ehipc3_100g [reg_read $BASE_ETILE_EHIPC3_100G 0x50B]
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000002]} {
			dashboard_set_property $dash rxcrc_covers_preamble_text_etile_ehipc3_100g text "RX CRC calculated over frame plus preamble"
			} else {
			dashboard_set_property $dash rxcrc_covers_preamble_text_etile_ehipc3_100g text "RX CRC calculated over Ethernet Frame"
           }
		if {[expr $rxmac_value_etile_ehipc3_100g & 0x00000001]} {
			dashboard_set_property $dash en_pp_rx_text_etile_ehipc3_100g text "Enabled"
			} else {
			dashboard_set_property $dash en_pp_rx_text_etile_ehipc3_100g text "Disabled"
           }
		
}

proc proc_read_tx_stats_etile_ehipc3_100g {} {

global dash
global BASE_ETILE_EHIPC3_100G

#puts "Reading TX MAC Statistics Counters"

	#Pausing - TX Shadow Request
	reg_write $BASE_ETILE_EHIPC3_100G 0x845 0x4
	
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x800]
		dashboard_set_property $dash cntr_tx_fragments_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x802]
		dashboard_set_property $dash cntr_tx_jabbers_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x804]
		dashboard_set_property $dash cntr_tx_fcs_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x806]
		dashboard_set_property $dash cntr_tx_fcs_err_okpkt_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x808]
		dashboard_set_property $dash cntr_tx_mcast_data_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x80A]
		dashboard_set_property $dash cntr_tx_bcast_data_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x80C]
		dashboard_set_property $dash cntr_tx_ucast_data_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x80E]
		dashboard_set_property $dash cntr_tx_mcast_ctrl_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x801]
		dashboard_set_property $dash cntr_tx_bcast_ctrl_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x812]
		dashboard_set_property $dash cntr_tx_ucast_ctrl_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x814]
		dashboard_set_property $dash cntr_tx_pause_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x816]
		dashboard_set_property $dash cntr_tx_64b_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x818]
		dashboard_set_property $dash cntr_tx_65to127b_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x81A]
		dashboard_set_property $dash cntr_tx_128to255b_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x81C]
		dashboard_set_property $dash cntr_tx_256to511b_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x81E]
		dashboard_set_property $dash cntr_tx_512to1023b_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x820]
		dashboard_set_property $dash cntr_tx_1024to1518b_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x822]
		dashboard_set_property $dash cntr_tx_1519tomaxb_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x824]
		dashboard_set_property $dash cntr_tx_oversize_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x826]
		dashboard_set_property $dash cntr_tx_mcast_data_ok_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x828]
		dashboard_set_property $dash cntr_tx_bcast_data_ok_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x82A]
		dashboard_set_property $dash cntr_tx_ucast_data_ok_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x82C]
		dashboard_set_property $dash cntr_tx_mcast_ctrl_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x82E]
		dashboard_set_property $dash cntr_tx_bcast_ctrl_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x830]
		dashboard_set_property $dash cntr_tx_ucast_ctrl_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x832]
		dashboard_set_property $dash cntr_tx_pause_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x834]
		dashboard_set_property $dash cntr_tx_runt_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x836]
		dashboard_set_property $dash cntr_tx_st_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x838]
		dashboard_set_property $dash cntr_tx_lenerr_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x83A]
		dashboard_set_property $dash cntr_tx_pfc_err_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x83C]
		dashboard_set_property $dash cntr_tx_pfc_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x860]
		dashboard_set_property $dash cntr_tx_payloadoctetsok_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x862]
		dashboard_set_property $dash txoctetsok_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x864]
		dashboard_set_property $dash cntr_tx_malformed_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x866]
		dashboard_set_property $dash cntr_tx_dropped_d text "$tx_count_etile_ehipc3_100g"
		
	set tx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x868]
		dashboard_set_property $dash cntr_tx_badlt_d text "$tx_count_etile_ehipc3_100g"
		
	#Un-Pausing - TX Shadow Request
	reg_write $BASE_ETILE_EHIPC3_100G 0x845 0x0
}

proc proc_read_rx_stats_etile_ehipc3_100g {} {

global dash
global BASE_ETILE_EHIPC3_100G

#puts "Reading RX MAC Statistics Counters"

	#Pausing - TX Shadow Request
	reg_write $BASE_ETILE_EHIPC3_100G 0x945 0x4
	
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x900]
		dashboard_set_property $dash cntr_rx_fragments_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x902]
		dashboard_set_property $dash cntr_rx_jabbers_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x904]
		dashboard_set_property $dash cntr_rx_fcs_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x906]
		dashboard_set_property $dash cntr_rx_fcs_err_okpkt_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x908]
		dashboard_set_property $dash cntr_rx_mcast_data_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x90A]
		dashboard_set_property $dash cntr_rx_bcast_data_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x90C]
		dashboard_set_property $dash cntr_rx_ucast_data_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x90E]
		dashboard_set_property $dash cntr_rx_mcast_ctrl_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x901]
		dashboard_set_property $dash cntr_rx_bcast_ctrl_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x912]
		dashboard_set_property $dash cntr_rx_ucast_ctrl_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x914]
		dashboard_set_property $dash cntr_rx_pause_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x916]
		dashboard_set_property $dash cntr_rx_64b_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x918]
		dashboard_set_property $dash cntr_rx_65to127b_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x91A]
		dashboard_set_property $dash cntr_rx_128to255b_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x91C]
		dashboard_set_property $dash cntr_rx_256to511b_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x91E]
		dashboard_set_property $dash cntr_rx_512to1023b_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x920]
		dashboard_set_property $dash cntr_rx_1024to1518b_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x922]
		dashboard_set_property $dash cntr_rx_1519tomaxb_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x924]
		dashboard_set_property $dash cntr_rx_oversize_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x926]
		dashboard_set_property $dash cntr_rx_mcast_data_ok_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x928]
		dashboard_set_property $dash cntr_rx_bcast_data_ok_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x92A]
		dashboard_set_property $dash cntr_rx_ucast_data_ok_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x92C]
		dashboard_set_property $dash cntr_rx_mcast_ctrl_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x92E]
		dashboard_set_property $dash cntr_rx_bcast_ctrl_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x930]
		dashboard_set_property $dash cntr_rx_ucast_ctrl_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x932]
		dashboard_set_property $dash cntr_rx_pause_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x934]
		dashboard_set_property $dash cntr_rx_runt_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x936]
		dashboard_set_property $dash cntr_rx_st_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x938]
		dashboard_set_property $dash cntr_rx_lenerr_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x93A]
		dashboard_set_property $dash cntr_rx_pfc_err_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x93C]
		dashboard_set_property $dash cntr_rx_pfc_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x960]
		dashboard_set_property $dash cntr_rx_payloadoctetsok_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x962]
		dashboard_set_property $dash rxoctetsok_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x964]
		dashboard_set_property $dash cntr_rx_malformed_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x966]
		dashboard_set_property $dash cntr_rx_dropped_d text "$rx_count_etile_ehipc3_100g"
		
	set rx_count_etile_ehipc3_100g [stats_read $BASE_ETILE_EHIPC3_100G 0x968]
		dashboard_set_property $dash cntr_rx_badlt_d text "$rx_count_etile_ehipc3_100g"
		
	#Un-Pausing - TX Shadow Request
	reg_write $BASE_ETILE_EHIPC3_100G 0x945 0x0
}

proc proc_reset_tx_stats_etile_ehipc3_100g {} {

	global dash
	global BASE_ETILE_EHIPC3_100G
	puts "Reseting TX MAC Statistics Counters"
	reg_write $BASE_ETILE_EHIPC3_100G 0x845 0x1
	after 10
	reg_write $BASE_ETILE_EHIPC3_100G 0x845 0x0
	after 10
	proc_read_tx_stats_etile_ehipc3_100g

}

proc proc_reset_rx_stats_etile_ehipc3_100g {} {

	global dash
	global BASE_ETILE_EHIPC3_100G
	puts "Reseting RX MAC Statistics Counters"
	reg_write $BASE_ETILE_EHIPC3_100G 0x945 0x1
	after 10
	reg_write $BASE_ETILE_EHIPC3_100G 0x945 0x0
	after 10
	proc_read_rx_stats_etile_ehipc3_100g

}

proc proc_read_fec_stats {} {
	global dash
	global BASE_ETILE_EHIPC3_100G_FEC
	global corrected_cw0 
	global uncorrected_cw0 
	global corrected_symbol0
	global corrected_bits_0_to_1_lane0
	global corrected_bits_1_to_0_lane0
	global corrected_symbols
	global rate
	global pattern
	#puts "Reading FEC Statistics"
	proc_read_fec_stats_backend
	proc_read_fec_stats_GUIupdate
	
	
}


proc proc_read_fec_stats_backend {} {
	global dash
	global BASE_ETILE_EHIPC3_100G_FEC
	global corrected_cw0 
	global uncorrected_cw0 
	global corrected_symbol0 
	global corrected_bits_0_to_1_lane0
	global corrected_bits_1_to_0_lane0
	global corrected_symbols
	global rate
	global pattern
	
	read_fec_error_counters
}

proc read_fec_error_counters {} {
	global dash
	global BASE_ETILE_EHIPC3_100G_FEC
	global corrected_cw0 
	global uncorrected_cw0 
	global corrected_symbol0
	global corrected_bits_0_to_1_lane0
	global corrected_bits_1_to_0_lane0
	global corrected_symbols
	
	proc bin2dec bin {
		if {$bin == 0} {
			return 0
		} elseif {[string match -* $bin]} {
			set sign -
			set bin [string range $bin[set bin {}] 1 end]
		} else {
			set sign {}
		}
		return $sign[expr 0b$bin]
	}


#Enable Snapshot#
reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x108 0x0f 
#Corrected Codewords
#Lane 0
set corrected_cw0_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x200]
set corrected_cw1_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x201]
set corrected_cw2_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x202]
set corrected_cw3_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x203]
set corrected_cw4_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x204]
set corrected_cw5_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x205]
set corrected_cw6_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x206]
set corrected_cw7_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x207]
set temp0_corrected_cw_lane0 [split [concat [format %0.8b $corrected_cw7_lane0] [format %0.8b $corrected_cw6_lane0] [format %0.8b $corrected_cw5_lane0] [format %0.8b $corrected_cw4_lane0] [format %0.8b $corrected_cw3_lane0] [format %0.8b $corrected_cw2_lane0] [format %0.8b $corrected_cw1_lane0] [format %0.8b $corrected_cw0_lane0]  ""] " "]
set temp1_corrected_cw_lane0 [join $temp0_corrected_cw_lane0 ""]
set corrected_cw0 [bin2dec $temp1_corrected_cw_lane0]

#UnCorrected Codewords
#Lane 0
set uncorrected_cw0_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x220]
set uncorrected_cw1_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x221]
set uncorrected_cw2_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x222]
set uncorrected_cw3_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x223]
set uncorrected_cw4_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x224]
set uncorrected_cw5_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x225]
set uncorrected_cw6_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x226]
set uncorrected_cw7_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x227]
set temp0_uncorrected_cw_lane0 [split [concat [format %0.8b $uncorrected_cw7_lane0] [format %0.8b $uncorrected_cw6_lane0] [format %0.8b $uncorrected_cw5_lane0] [format %0.8b $uncorrected_cw4_lane0] [format %0.8b $uncorrected_cw3_lane0] [format %0.8b $uncorrected_cw2_lane0] [format %0.8b $uncorrected_cw1_lane0] [format %0.8b $uncorrected_cw0_lane0]  ""] " "]
set temp1_uncorrected_cw_lane0 [join $temp0_uncorrected_cw_lane0 ""]
set uncorrected_cw0 [bin2dec $temp1_uncorrected_cw_lane0]

#Corrected Symbols 
#Lane 0
set corrected_sym0_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x240]
set corrected_sym1_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x241]
set corrected_sym2_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x242]
set corrected_sym3_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x243]
set corrected_sym4_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x244]
set corrected_sym5_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x245]
set corrected_sym6_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x246]
set corrected_sym7_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x247]
set temp0_corrected_sym_lane0 [split [concat [format %0.8b $corrected_sym7_lane0] [format %0.8b $corrected_sym6_lane0] [format %0.8b $corrected_sym5_lane0] [format %0.8b $corrected_sym4_lane0] [format %0.8b $corrected_sym3_lane0] [format %0.8b $corrected_sym2_lane0] [format %0.8b $corrected_sym1_lane0] [format %0.8b $corrected_sym0_lane0]  ""] " "]
set temp1_corrected_sym_lane0 [join $temp0_corrected_sym_lane0 ""]
set corrected_symbol0 [bin2dec $temp1_corrected_sym_lane0]
# #Lane 1
# set corrected_sym0_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x248]
# set corrected_sym1_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x249]
# set corrected_sym2_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x24A]
# set corrected_sym3_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x24B]
# set corrected_sym4_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x24C]
# set corrected_sym5_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x24D]
# set corrected_sym6_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x24E]
# set corrected_sym7_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x24F]
# set temp0_corrected_sym_lane1 [split [concat [format %0.8b $corrected_sym7_lane1] [format %0.8b $corrected_sym6_lane1] [format %0.8b $corrected_sym5_lane1] [format %0.8b $corrected_sym4_lane1] [format %0.8b $corrected_sym3_lane1] [format %0.8b $corrected_sym2_lane1] [format %0.8b $corrected_sym1_lane1] [format %0.8b $corrected_sym0_lane1]  ""] " "]
# set temp1_corrected_sym_lane1 [join $temp0_corrected_sym_lane1 ""]
# set corrected_symbol1 [bin2dec $temp1_corrected_sym_lane1]
# #Lane 2
# set corrected_sym0_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x250]
# set corrected_sym1_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x251]
# set corrected_sym2_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x252]
# set corrected_sym3_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x253]
# set corrected_sym4_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x254]
# set corrected_sym5_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x255]
# set corrected_sym6_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x256]
# set corrected_sym7_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x257]
# set temp0_corrected_sym_lane2 [split [concat [format %0.8b $corrected_sym7_lane2] [format %0.8b $corrected_sym6_lane2] [format %0.8b $corrected_sym5_lane2] [format %0.8b $corrected_sym4_lane2] [format %0.8b $corrected_sym3_lane2] [format %0.8b $corrected_sym2_lane2] [format %0.8b $corrected_sym1_lane2] [format %0.8b $corrected_sym0_lane2]  ""] " "]
# set temp1_corrected_sym_lane2 [join $temp0_corrected_sym_lane2 ""]
# set corrected_symbol2 [bin2dec $temp1_corrected_sym_lane2]
# #Lane 3
# set corrected_sym0_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x258]
# set corrected_sym1_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x259]
# set corrected_sym2_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x25A]
# set corrected_sym3_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x25B]
# set corrected_sym4_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x25C]
# set corrected_sym5_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x25D]
# set corrected_sym6_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x25E]
# set corrected_sym7_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x25F]
# set temp0_corrected_sym_lane3 [split [concat [format %0.8b $corrected_sym7_lane3] [format %0.8b $corrected_sym6_lane3] [format %0.8b $corrected_sym5_lane3] [format %0.8b $corrected_sym4_lane3] [format %0.8b $corrected_sym3_lane3] [format %0.8b $corrected_sym2_lane3] [format %0.8b $corrected_sym1_lane3] [format %0.8b $corrected_sym0_lane3]  ""] " "]
# set temp1_corrected_sym_lane3 [join $temp0_corrected_sym_lane3 ""]
# set corrected_symbol3 [bin2dec $temp1_corrected_sym_lane3]

#Corrected Bits_0_to_1
#Lane 0
set cb_zero_to_one_0_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x260]
set cb_zero_to_one_1_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x261]
set cb_zero_to_one_2_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x262]
set cb_zero_to_one_3_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x263]
set cb_zero_to_one_4_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x264]
set cb_zero_to_one_5_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x265]
set cb_zero_to_one_6_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x266]
set cb_zero_to_one_7_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x267]
set temp0_cb_zero_to_one_lane0 [split [concat [format %0.8b $cb_zero_to_one_7_lane0] [format %0.8b $cb_zero_to_one_6_lane0] [format %0.8b $cb_zero_to_one_5_lane0] [format %0.8b $cb_zero_to_one_4_lane0] [format %0.8b $cb_zero_to_one_3_lane0] [format %0.8b $cb_zero_to_one_2_lane0] [format %0.8b $cb_zero_to_one_1_lane0] [format %0.8b $cb_zero_to_one_0_lane0]  ""] " "]
set temp1_cb_zero_to_one_lane0 [join $temp0_cb_zero_to_one_lane0 ""]
set corrected_bits_0_to_1_lane0 [bin2dec $temp1_cb_zero_to_one_lane0]
# #Lane 1
# set cb_zero_to_one_0_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x268]
# set cb_zero_to_one_1_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x269]
# set cb_zero_to_one_2_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x26A]
# set cb_zero_to_one_3_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x26B]
# set cb_zero_to_one_4_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x26C]
# set cb_zero_to_one_5_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x26D]
# set cb_zero_to_one_6_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x26E]
# set cb_zero_to_one_7_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x26F]
# set temp0_cb_zero_to_one_lane1 [split [concat [format %0.8b $cb_zero_to_one_7_lane1] [format %0.8b $cb_zero_to_one_6_lane1] [format %0.8b $cb_zero_to_one_5_lane1] [format %0.8b $cb_zero_to_one_4_lane1] [format %0.8b $cb_zero_to_one_3_lane1] [format %0.8b $cb_zero_to_one_2_lane1] [format %0.8b $cb_zero_to_one_1_lane1] [format %0.8b $cb_zero_to_one_0_lane1]  ""] " "]
# set temp1_cb_zero_to_one_lane1 [join $temp0_cb_zero_to_one_lane1 ""]
# set corrected_bits_0_to_1_lane1 [bin2dec $temp1_cb_zero_to_one_lane1]
# #Lane 2
# set cb_zero_to_one_0_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x270]
# set cb_zero_to_one_1_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x271]
# set cb_zero_to_one_2_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x272]
# set cb_zero_to_one_3_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x273]
# set cb_zero_to_one_4_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x274]
# set cb_zero_to_one_5_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x275]
# set cb_zero_to_one_6_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x276]
# set cb_zero_to_one_7_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x277]
# set temp0_cb_zero_to_one_lane2 [split [concat [format %0.8b $cb_zero_to_one_7_lane2] [format %0.8b $cb_zero_to_one_6_lane2] [format %0.8b $cb_zero_to_one_5_lane2] [format %0.8b $cb_zero_to_one_4_lane2] [format %0.8b $cb_zero_to_one_3_lane2] [format %0.8b $cb_zero_to_one_2_lane2] [format %0.8b $cb_zero_to_one_1_lane2] [format %0.8b $cb_zero_to_one_0_lane2]  ""] " "]
# set temp1_cb_zero_to_one_lane2 [join $temp0_cb_zero_to_one_lane2 ""]
# set corrected_bits_0_to_1_lane2 [bin2dec $temp1_cb_zero_to_one_lane2]
# #Lane 3
# set cb_zero_to_one_0_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x278]
# set cb_zero_to_one_1_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x279]
# set cb_zero_to_one_2_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x27A]
# set cb_zero_to_one_3_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x27B]
# set cb_zero_to_one_4_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x27C]
# set cb_zero_to_one_5_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x27D]
# set cb_zero_to_one_6_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x27E]
# set cb_zero_to_one_7_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x27F]
# set temp0_cb_zero_to_one_lane3 [split [concat [format %0.8b $cb_zero_to_one_7_lane3] [format %0.8b $cb_zero_to_one_6_lane3] [format %0.8b $cb_zero_to_one_5_lane3] [format %0.8b $cb_zero_to_one_4_lane3] [format %0.8b $cb_zero_to_one_3_lane3] [format %0.8b $cb_zero_to_one_2_lane3] [format %0.8b $cb_zero_to_one_1_lane3] [format %0.8b $cb_zero_to_one_0_lane3]  ""] " "]
# set temp1_cb_zero_to_one_lane3 [join $temp0_cb_zero_to_one_lane3 ""]
# set corrected_bits_0_to_1_lane3 [bin2dec $temp1_cb_zero_to_one_lane3]

#Corrected Bits_1_to_0
#Lane 0
set cb_one_to_zero_0_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x280]
set cb_one_to_zero_1_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x281]
set cb_one_to_zero_2_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x282]
set cb_one_to_zero_3_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x283]
set cb_one_to_zero_4_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x284]
set cb_one_to_zero_5_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x285]
set cb_one_to_zero_6_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x286]
set cb_one_to_zero_7_lane0 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x287]
set temp0_cb_one_to_zero_lane0 [split [concat [format %0.8b $cb_one_to_zero_7_lane0] [format %0.8b $cb_one_to_zero_6_lane0] [format %0.8b $cb_one_to_zero_5_lane0] [format %0.8b $cb_one_to_zero_4_lane0] [format %0.8b $cb_one_to_zero_3_lane0] [format %0.8b $cb_one_to_zero_2_lane0] [format %0.8b $cb_one_to_zero_1_lane0] [format %0.8b $cb_one_to_zero_0_lane0]  ""] " "]
set temp1_cb_one_to_zero_lane0 [join $temp0_cb_one_to_zero_lane0 ""]
set corrected_bits_1_to_0_lane0 [bin2dec $temp1_cb_one_to_zero_lane0]
# #Lane 1
# set cb_one_to_zero_0_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x288]
# set cb_one_to_zero_1_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x289]
# set cb_one_to_zero_2_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x28A]
# set cb_one_to_zero_3_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x28B]
# set cb_one_to_zero_4_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x28C]
# set cb_one_to_zero_5_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x28D]
# set cb_one_to_zero_6_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x28E]
# set cb_one_to_zero_7_lane1 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x28F]
# set temp0_cb_one_to_zero_lane1 [split [concat [format %0.8b $cb_one_to_zero_7_lane1] [format %0.8b $cb_one_to_zero_6_lane1] [format %0.8b $cb_one_to_zero_5_lane1] [format %0.8b $cb_one_to_zero_4_lane1] [format %0.8b $cb_one_to_zero_3_lane1] [format %0.8b $cb_one_to_zero_2_lane1] [format %0.8b $cb_one_to_zero_1_lane1] [format %0.8b $cb_one_to_zero_0_lane1]  ""] " "]
# set temp1_cb_one_to_zero_lane1 [join $temp0_cb_one_to_zero_lane1 ""]
# set corrected_bits_1_to_0_lane1 [bin2dec $temp1_cb_one_to_zero_lane1]
# #Lane 2
# set cb_one_to_zero_0_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x290]
# set cb_one_to_zero_1_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x291]
# set cb_one_to_zero_2_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x292]
# set cb_one_to_zero_3_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x293]
# set cb_one_to_zero_4_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x294]
# set cb_one_to_zero_5_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x295]
# set cb_one_to_zero_6_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x296]
# set cb_one_to_zero_7_lane2 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x297]
# set temp0_cb_one_to_zero_lane2 [split [concat [format %0.8b $cb_one_to_zero_7_lane2] [format %0.8b $cb_one_to_zero_6_lane2] [format %0.8b $cb_one_to_zero_5_lane2] [format %0.8b $cb_one_to_zero_4_lane2] [format %0.8b $cb_one_to_zero_3_lane2] [format %0.8b $cb_one_to_zero_2_lane2] [format %0.8b $cb_one_to_zero_1_lane2] [format %0.8b $cb_one_to_zero_0_lane2]  ""] " "]
# set temp1_cb_one_to_zero_lane2 [join $temp0_cb_one_to_zero_lane2 ""]
# set corrected_bits_1_to_0_lane2 [bin2dec $temp1_cb_one_to_zero_lane2]
# #Lane 3
# set cb_one_to_zero_0_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x298]
# set cb_one_to_zero_1_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x299]
# set cb_one_to_zero_2_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x29A]
# set cb_one_to_zero_3_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x29B]
# set cb_one_to_zero_4_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x29C]
# set cb_one_to_zero_5_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x29D]
# set cb_one_to_zero_6_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x29E]
# set cb_one_to_zero_7_lane3 [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x29F]
# set temp0_cb_one_to_zero_lane3 [split [concat [format %0.8b $cb_one_to_zero_7_lane3] [format %0.8b $cb_one_to_zero_6_lane3] [format %0.8b $cb_one_to_zero_5_lane3] [format %0.8b $cb_one_to_zero_4_lane3] [format %0.8b $cb_one_to_zero_3_lane3] [format %0.8b $cb_one_to_zero_2_lane3] [format %0.8b $cb_one_to_zero_1_lane3] [format %0.8b $cb_one_to_zero_0_lane3]  ""] " "]
# set temp1_cb_one_to_zero_lane3 [join $temp0_cb_one_to_zero_lane3 ""]
# set corrected_bits_1_to_0_lane3 [bin2dec $temp1_cb_one_to_zero_lane3]

#Number of corrected symbols per codeword
#set sum_corrected_symbols [ expr {$corrected_symbol0 + $corrected_symbol1 + $corrected_symbol2 + $corrected_symbol3}]
if {$corrected_cw0 == 0} {
		set div_operation 0
	} else {
		# set div_operation [expr {$sum_corrected_symbols / double ($corrected_cw0)}] 
		set div_operation [expr {$corrected_cw0 / double ($corrected_cw0)}] 
		}

set corrected_symbols $div_operation

#Step 5f :Disable Snapshot#
reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x108 0x0 
}


proc proc_read_fec_stats_GUIupdate {} {
	global dash
	global corrected_cw0 
	global uncorrected_cw0 
	global corrected_symbol0
	global corrected_bits_0_to_1_lane0
	global corrected_bits_1_to_0_lane0
	global corrected_symbols
	global rate
	global pattern
	global BASE_ETILE_EHIPC3_100G_FEC
	
	widget_textBox 0 rate tx_fec_err_inj 1 "0x[format %0.2x [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x1e0]]" 10 50
	widget_textBox 0 pattern tx_fec_err_inj 1 "0x[format %0.2x [reg_read $BASE_ETILE_EHIPC3_100G_FEC 0x1e1]]" 10 50
	
	
	
#Corrected CodeWords
	widget_label 0 corrected_cw0 corrected_cw_group "[set corrected_cw0]"

#UnCorrected CodeWords
	widget_label 0 uncorrected_cw0 uncorrected_cw_group "[set uncorrected_cw0]"


#Corrected Symbols
	widget_labelwidth 0 corrected_symbol corrected_symbols_n_bits "[set corrected_symbol0]" 125


#Corrected Bits_0_to_1
	widget_labelwidth 0 corrected_bits_0_to_1 corrected_symbols_n_bits "[set corrected_bits_0_to_1_lane0]" 125


#Corrected Bits_1_to_0
	widget_labelwidth 0 corrected_bits_1_to_0 corrected_symbols_n_bits "[set corrected_bits_1_to_0_lane0]" 125

#Number of symbols corrected per codeword
widget_label 0 corrected_symbols_per_codeword corrected_symbols_group "[set corrected_symbols]"

}


proc clear_fec_counters {} {

	global dash
	global BASE_ETILE_EHIPC3_100G_FEC
	global corrected_cw0 
	global uncorrected_cw0 
	global corrected_symbol0
	global corrected_bits_0_to_1_lane0
	global corrected_bits_1_to_0_lane0
	global corrected_symbols
	#puts "Reseting FEC Statistics"
	
	#Step 5a : Clear Counter#
	reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x108 0xf0 

	#Corrected Codewords
	widget_label 0 corrected_cw0 corrected_cw_group "0"

	#UnCorrected CodeWords

		widget_label 0 uncorrected_cw0 uncorrected_cw_group "0"

	#Corrected Symbols
	#widget_label 0 lane_label$i corrected_symbols_n_bits "lane[set i]"
		widget_labelwidth 0 corrected_symbol corrected_symbols_n_bits "0" 125
	

	#Corrected Bits_0_to_1
	
		#widget_label 0 lane_label$i corrected_symbols_n_bits "lane[set i]"
		widget_labelwidth 0 corrected_bits_0_to_1 corrected_symbols_n_bits "0" 125
	

	#Corrected Bits_1_to_0
	
		#widget_label 0 lane_label$i corrected_symbols_n_bits "lane[set i]"
		widget_labelwidth 0 corrected_bits_1_to_0 corrected_symbols_n_bits "0" 125
	
	#Number of symbols corrected per codeword
	widget_label 0 corrected_symbols_per_codeword corrected_symbols_group "0"
	
}

proc inject_error {} {

global dash
global BASE_ETILE_EHIPC3_100G_FEC

	#rate 
	set rate0 [dashboard_get_property $dash rate text]
	reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x1e0 $rate0 
	#8 bit pattern 
	set pattern0 [dashboard_get_property $dash pattern text]
	reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x1e1 $pattern0 		
}

proc inject_error_clear {} {

global dash
global BASE_ETILE_EHIPC3_100G_FEC

	#rate 		
	reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x1e0 0x0 
	#8 bit pattern 		
	reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x1e1 0x0
	
	proc_read_fec_stats		
}

proc pre_load_error {} {

	global dash
	global BASE_ETILE_EHIPC3_100G_FEC
		
		dashboard_set_property $dash rate text 0x01
		dashboard_set_property $dash pattern text 0x01
		#rate
		reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x1e0 0x01
		#patter
		reg_write $BASE_ETILE_EHIPC3_100G_FEC 0x1e1 0x01 	
				
			
}

proc freeze_buttons {} {
	
	global dash	
	global freeze1
	global ip_sub_variant_option	
	global rs_enabled
	global anlt_enabled
	
	global ical_apply_recipe_freeze
	
	global freeze1
	global freeze2
	global freeze3
	global freeze4
	global freeze5
	global freeze6
	global freeze7
			
	global textbox_freeze1
	global textbox_freeze2
	global textbox_freeze3
	global textbox_freeze4
	global textbox_freeze5
	global textbox_freeze6
	global textbox_freeze7
	
	dashboard_set_property $dash launch enabled false
	dashboard_set_property $dash list_jtag enabled false
	dashboard_set_property $dash set_jtag enabled false
	
	dashboard_set_property $dash eio_sys_rst_etile_ehipc3_100g enabled false
	dashboard_set_property $dash soft_txp_rst_etile_ehipc3_100g enabled false
	dashboard_set_property $dash soft_rxp_rst_etile_ehipc3_100g enabled false
	
	dashboard_set_property $dash read_pcs_status_etile_ehipc3_100g enabled false
	
	dashboard_set_property $dash read_txmac_status_etile_ehipc3_100g enabled false
	dashboard_set_property $dash read_rxmac_status_etile_ehipc3_100g enabled false
	
	dashboard_set_property $dash ilb_lpbk_etile_ehipc3_100g enabled false
	dashboard_set_property $dash iadt_lpbk_etile_ehipc3_100g enabled false
	dashboard_set_property $dash imiss_lpbk_etile_ehipc3_100g enabled false
	
	dashboard_set_property $dash read_tx_stats_etile_ehipc3_100g enabled false
	dashboard_set_property $dash read_rx_stats_etile_ehipc3_100g enabled false
	dashboard_set_property $dash reset_tx_stats_etile_ehipc3_100g enabled false
	dashboard_set_property $dash reset_rx_stats_etile_ehipc3_100g enabled false
	
	
	set ical_apply_recipe_freeze [dashboard_get_property $dash ical_recipe_apply enabled]
	dashboard_set_property $dash ical_recipe_apply enabled false
	
	if {$rs_enabled == 1} {
				dashboard_set_property $dash read_fec_stats enabled false
				dashboard_set_property $dash fec_inject_error enabled false
				dashboard_set_property $dash fec_inject_error_clear enabled false
				dashboard_set_property $dash clear_fec_counters enabled false
				dashboard_set_property $dash fec_preload_error enabled false
			}
			
	set freeze1 [dashboard_get_property $dash pkt_gen_random_gap enabled]
	set freeze2 [dashboard_get_property $dash pkt_gen_no_gap enabled]
	set freeze3 [dashboard_get_property $dash pkt_gen_fixed enabled]
	set freeze4 [dashboard_get_property $dash pkt_gen_incr enabled]
	set freeze5 [dashboard_get_property $dash set_source_add enabled]
	set freeze6 [dashboard_get_property $dash set_dest_add enabled]
	set freeze7 [dashboard_get_property $dash mac_loopback enabled]
	
	set textbox_freeze1 [dashboard_get_property $dash source_Add editable]
	set textbox_freeze2 [dashboard_get_property $dash dest_Add editable]
	set textbox_freeze3 [dashboard_get_property $dash pkt_byte_size_val editable]
	set textbox_freeze4 [dashboard_get_property $dash pkt_num_val editable]
	set textbox_freeze5 [dashboard_get_property $dash pkt_byte_size_begin_val editable]
	set textbox_freeze6 [dashboard_get_property $dash pkt_byte_size_end_val editable]
	set textbox_freeze7 [dashboard_get_property $dash pkt_incr_num_val editable]
	
	
	dashboard_set_property $dash pkt_gen_random_gap enabled false	
	dashboard_set_property $dash pkt_gen_no_gap enabled false	
	dashboard_set_property $dash pkt_gen_fixed enabled false	
	dashboard_set_property $dash pkt_gen_incr enabled false		
	dashboard_set_property $dash set_source_add enabled false		
	dashboard_set_property $dash set_dest_add enabled false		
	dashboard_set_property $dash mac_loopback enabled false		
	dashboard_set_property $dash pkt_cntrl_en enabled false		
	
	
	if { [string match [dashboard_get_property $dash pkt_cntrl_en checked] "true"] & [string match [dashboard_get_property $dash mac_loopback checked] "false"] } {
	dashboard_set_property $dash source_Add editable 0
	dashboard_set_property $dash dest_Add editable 0
	dashboard_set_property $dash pkt_byte_size_val editable 0
	dashboard_set_property $dash pkt_num_val editable 0
	dashboard_set_property $dash pkt_byte_size_begin_val editable 0
	dashboard_set_property $dash pkt_byte_size_end_val editable 0
	dashboard_set_property $dash pkt_incr_num_val editable 0
	}
	
	#freeze_buttons_pma	
	#dashboard_set_property $dash etile_pma_continuous_read enabled false
	
	if {$anlt_enabled} {
		dashboard_set_property $dash read_kr4_status enabled false
		dashboard_set_property $dash reset_seq enabled false
		dashboard_set_property $dash seq_force_mode enabled false
		dashboard_set_property $dash seq_force enabled false
		dashboard_set_property $dash disable_if_timer enabled false
		dashboard_set_property $dash lt_disable_max_timer enabled false
		dashboard_set_property $dash ignore_nonce enabled false
		dashboard_set_property $dash fec_request_rsfec enabled false
		dashboard_set_property $dash fec_negotitation_rsfec enabled false			
	
	}
		
}

proc unfreeze_buttons {} {
	
	global dash
	global freeze1
	global ip_sub_variant_option	
	global rs_enabled
	global anlt_enabled
	
	global ical_apply_recipe_freeze
	
	global freeze1
	global freeze2
	global freeze3
	global freeze4
	global freeze5
	global freeze6
	global freeze7
	
	global textbox_freeze1
	global textbox_freeze2
	global textbox_freeze3
	global textbox_freeze4
	global textbox_freeze5
	global textbox_freeze6
	global textbox_freeze7	
	
	dashboard_set_property $dash launch enabled true
	dashboard_set_property $dash list_jtag enabled true
	dashboard_set_property $dash set_jtag enabled true
	
	dashboard_set_property $dash eio_sys_rst_etile_ehipc3_100g enabled true
	dashboard_set_property $dash soft_txp_rst_etile_ehipc3_100g enabled true
	dashboard_set_property $dash soft_rxp_rst_etile_ehipc3_100g enabled true
	
	dashboard_set_property $dash read_pcs_status_etile_ehipc3_100g enabled true
	
	dashboard_set_property $dash read_txmac_status_etile_ehipc3_100g enabled true
	dashboard_set_property $dash read_rxmac_status_etile_ehipc3_100g enabled true
	
	dashboard_set_property $dash ilb_lpbk_etile_ehipc3_100g enabled true
	dashboard_set_property $dash iadt_lpbk_etile_ehipc3_100g enabled true
	dashboard_set_property $dash imiss_lpbk_etile_ehipc3_100g enabled true
	
	dashboard_set_property $dash read_tx_stats_etile_ehipc3_100g enabled true
	dashboard_set_property $dash read_rx_stats_etile_ehipc3_100g enabled true
	dashboard_set_property $dash reset_tx_stats_etile_ehipc3_100g enabled true
	dashboard_set_property $dash reset_rx_stats_etile_ehipc3_100g enabled true
	
	dashboard_set_property $dash ical_recipe_apply enabled $ical_apply_recipe_freeze
	
	if {$rs_enabled == 1} {
				dashboard_set_property $dash read_fec_stats enabled true
				dashboard_set_property $dash fec_inject_error enabled true
				dashboard_set_property $dash fec_inject_error_clear enabled true
				dashboard_set_property $dash clear_fec_counters enabled true
				dashboard_set_property $dash fec_preload_error enabled true
			}
		
	dashboard_set_property $dash pkt_gen_random_gap enabled $freeze1 
	dashboard_set_property $dash pkt_gen_no_gap enabled $freeze2
	dashboard_set_property $dash pkt_gen_fixed enabled $freeze3 
	dashboard_set_property $dash pkt_gen_incr enabled $freeze4
	dashboard_set_property $dash set_source_add enabled $freeze5
	dashboard_set_property $dash set_dest_add enabled $freeze6
	dashboard_set_property $dash mac_loopback enabled $freeze7
	
	dashboard_set_property $dash pkt_cntrl_en enabled true
	
	if { [string match [dashboard_get_property $dash pkt_cntrl_en checked] "true"] & [string match [dashboard_get_property $dash mac_loopback checked] "false"] } {
	dashboard_set_property $dash source_Add editable $textbox_freeze1
	dashboard_set_property $dash dest_Add editable $textbox_freeze2
	dashboard_set_property $dash pkt_byte_size_val editable $textbox_freeze3
	dashboard_set_property $dash pkt_num_val editable $textbox_freeze4
	dashboard_set_property $dash pkt_byte_size_begin_val editable $textbox_freeze5
	dashboard_set_property $dash pkt_byte_size_end_val editable $textbox_freeze6
	dashboard_set_property $dash pkt_incr_num_val editable $textbox_freeze7
	
	}
	
	#unfreeze_buttons_pma	
	#dashboard_set_property $dash etile_pma_continuous_read enabled true
	
	if {$anlt_enabled} {
		dashboard_set_property $dash read_kr4_status enabled true
		dashboard_set_property $dash reset_seq enabled true
		dashboard_set_property $dash seq_force_mode enabled true
		dashboard_set_property $dash seq_force enabled true
		dashboard_set_property $dash disable_if_timer enabled true
		dashboard_set_property $dash lt_disable_max_timer enabled true
		dashboard_set_property $dash ignore_nonce enabled true
		dashboard_set_property $dash fec_request_rsfec enabled true
		dashboard_set_property $dash fec_negotitation_rsfec enabled true			
	
	}
	
}

proc proc_ical_recipe_dropdown {} {

global dash
global ical_recipe_option

	if {[string match [dashboard_get_property $dash ical_recipe_dropdown selectedItem] "Default"]} {
		set ical_recipe_option "def"
		dashboard_set_property $dash ical_recipe_apply enabled false		
		
	} elseif {[string match [dashboard_get_property $dash ical_recipe_dropdown selectedItem] "25G NRZ LR"]} {
		
		set ical_recipe_option "25g_nrz_lr"	
		dashboard_set_property $dash ical_recipe_apply enabled true 
		
	} elseif {[string match [dashboard_get_property $dash ical_recipe_dropdown selectedItem] "25G NRZ VSR"]} {
		
		set ical_recipe_option "25g_nrz_vsr"
		dashboard_set_property $dash ical_recipe_apply enabled true
		
	}  elseif {[string match [dashboard_get_property $dash ical_recipe_dropdown selectedItem] "10G NRZ"]} {
		
		set ical_recipe_option "10g_nrz_db"
		dashboard_set_property $dash ical_recipe_apply enabled true
		
	} 
	
	
}

proc proc_ical_recipe {} {

global dash
global ical_recipe_option

	if {$ical_recipe_option == "25g_nrz_lr"} {
		
		proc_ical_recipe_25g_nrz_lr	
		
	} elseif {$ical_recipe_option == "25g_nrz_vsr"} {
		
		proc_ical_recipe_25g_nrz_vsr
			
	} elseif {$ical_recipe_option == "10g_nrz_db"} {
		
		proc_ical_recipe_10g_nrz_db
			
	} 

}

proc proc_ical_recipe_10g_nrz_db {} {
	
global BASE_ETILE_EHIPC3_100G_XCVR_LO
global BASE_ETILE_EHIPC3_100G
	
	reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x1
	set_pma_reset 0
	reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x0
	proc_ical_recipe_10g_30db 0
	
}

proc proc_ical_recipe_25g_nrz_lr {} {
	
global BASE_ETILE_EHIPC3_100G_XCVR_LO
global BASE_ETILE_EHIPC3_100G	
	reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x1
	set_pma_reset 0
	reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x0
	proc_ical_recipe_28g_lr 0
	
}

proc proc_ical_recipe_25g_nrz_vsr {} {
	
global BASE_ETILE_EHIPC3_100G_XCVR_LO
global BASE_ETILE_EHIPC3_100G
	
	reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x1
	set_pma_reset 0
	reg_write $BASE_ETILE_EHIPC3_100G 0x310 0x0
	proc_ical_recipe_28g_vsr 0
	
}

proc proc_ical_recipe_10g_30db {base} {

	global dash_xcvr_debug_tool_kit version
	global jtag_master
	set avmm $jtag_master
	
	ctle_gs1_manual 2 $base $avmm
		
	ctle_gs2_manual 1 $base $avmm

	ctle_rf_b0_manual 1 $base $avmm

	ctle_rf_b1_manual 5 $base $avmm
		
	default_rf_p1max_manual $base $avmm
	
	#ctle_lfmax_manual 1 $base $avmm
	ctle_lfmax_manual 2 $base $avmm
	
	rf_p2_default $base $avmm
	
	default_rf_b0t $base $avmm
	
	dc_freeze $base $avmm
}

proc proc_ical_recipe_28g_lr {base} {

	global dash_xcvr_debug_tool_kit version
	global jtag_master
	set avmm $jtag_master
	
	ctle_gs1_manual 2 $base $avmm
		
	ctle_gs2_manual 2 $base $avmm

	ctle_rf_b0_manual 1 $base $avmm

	ctle_rf_b1_manual 1 $base $avmm
		
	rf_p1max_manual 6  $base $avmm
	
	ctle_lfmax_manual 3 $base $avmm
	
	rf_p2_default $base $avmm
	
	rf_b0t 10 $base $avmm
	
	dc_freeze $base $avmm
}

proc proc_ical_recipe_28g_vsr { base } {
	
	global dash_xcvr_debug_tool_kit version
	global jtag_master
	set avmm $jtag_master
	
	ctle_gs1_adaptive $base $avmm 
	
	ctle_gs2_adaptive $base $avmm
	
	ctle_rf_b0_adaptive $base $avmm
	
	ctle_rf_b1_adaptive $base $avmm
	
	default_rf_p1max_manual $base $avmm
	
	default_ctle_lfmax_manual $base $avmm
	
	default_rf_b0t $base $avmm
	
	dc_adaptive $base $avmm
	
}

proc ctle_gs1_manual  	{ dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0x904 $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x15 	$chan $avmm
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
	set value [expr $value & [expr 0xFF & ~0x21]] 
	#This should be 20^
    set value [expr $value | 0x21]
	#etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
	etile_pma_atribute 0x6c 0x20 $chan "$avmm"
}
proc ctle_gs1_adaptive  { chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x20]]
    set value [expr $value | 0x00]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_gs2_manual  	{ dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0x905 $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x15 	$chan $avmm
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x10]]
    set value [expr $value | 0x10]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_gs2_adaptive  { chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x10]]
    set value [expr $value | 0x00]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_rf_b0_manual  	{ dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0xD03 $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
	set value [etile_pma_atribute 0x2c 0x109 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x08]]
    set value [expr $value | 0x08]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_rf_b0_adaptive { chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x109 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x08]]
    set value [expr $value | 0x00]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_rf_b1_manual  	{ dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0xD04 $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
	set value [etile_pma_atribute 0x2c 0x109 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x10]]
    set value [expr $value | 0x10]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_rf_b1_adaptive { chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x109 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x10]]
    set value [expr $value | 0x00]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_lfmax_manual  { dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0x90A $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x15 	$chan $avmm
	# etile_pma_atribute 0x2c 0x108 $chan $avmm
	# etile_pma_atribute_rdmwrite 0x6c 0x20 	0x20 $chan $avmm
}
proc default_ctle_lfmax_manual  { chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0x90A $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X 15] 	$chan $avmm
	etile_pma_atribute 0xec 0x15 	$chan $avmm
	# etile_pma_atribute 0x2c 0x108 $chan $avmm
	# etile_pma_atribute_rdmwrite 0x6c 0x20 	0x20 $chan $avmm
}
proc rf_p1max_manual { dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0xD08 $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
	# etile_pma_atribute 0x2c 0x108 $chan $avmm
	# etile_pma_atribute_rdmwrite 0x6c 0x20 	0x20 $chan $avmm
}
proc rf_p2_default  	{chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0xD00 $chan $avmm
	etile_pma_atribute 0x6c 0x0 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
	set value [etile_pma_atribute 0x2c 0x109 $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~0x01]]
    set value [expr $value | 0x01]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc default_rf_p1max_manual { chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0xD08 $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X 15] 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
	# etile_pma_atribute 0x2c 0x108 $chan $avmm
	# etile_pma_atribute_rdmwrite 0x6c 0x20 	0x20 $chan $avmm
}
proc rf_b0t  	{ dec_val chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0x200B $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X $dec_val] 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
}
proc default_rf_b0t  	{ chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	etile_pma_atribute 0x2c 0x200B $chan $avmm
	etile_pma_atribute 0x6c 0x[format %X 0 ] 	$chan $avmm
	etile_pma_atribute 0xec 0x12 	$chan $avmm
}
proc ctle_lf_manual 	{ chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
	set value [expr $value & [expr 0xFF & ~0x2]]
    set value [expr $value | 0x2]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc ctle_lf_adaptive 	{ chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
	set value [expr $value & [expr 0xFF & ~0x2]]
    set value [expr $value | 0x0]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc dc_freeze  		{ chan avmm } {
	if {1}  { puts [lrange [info level [info level]] 0 2] }
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
	set value [expr $value & [expr 0xFF & ~0x01]]
    set value [expr $value | 0x01]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}
proc dc_adaptive  		{ chan avmm } {
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }
	set value [etile_pma_atribute 0x2c 0x108 $chan "$avmm"]
	set value [expr $value & [expr 0xFF & ~0x01]]
    set value [expr $value | 0x00]
	etile_pma_atribute 0x6c 0x[format %X $value] $chan "$avmm"
}

# proc set_pma_reset {chan} { 
	# global dash_xcvr_debug_tool_kit version
	# global jtag_master
	# #set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]		
	# set avmm $jtag_master
	# #dashboard_set_property $dash1 etile_reset_$chan enabled false
	# if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }; 
	# etile_rdmwrite 0x200 0xff 0x00 $chan $avmm
	# etile_rdmwrite 0x201 0xff 0x00 $chan $avmm
	# etile_rdmwrite 0x202 0xff 0x00 $chan $avmm
	# etile_rdmwrite 0x203 0xff 0x81 $chan $avmm
	# #Call the interrupt sequencer 
	# etile_rdmwrite 0x91 0x01 0x01  $chan $avmm	
	# #eli_read_all_phy
	# #dashboard_set_property $dash1 etile_reset_$chan enabled true
	
# }

# proc etile_rdmwrite 	{ address bitmask newval chan avmm } {
	# if {0} { puts [info level 0] }	
    # set value [etile_read_reg $address $chan "$avmm"]
    # set value [expr $value & [expr 0xFF & ~$bitmask]]
    # set value [expr $value | $newval]
	# etile_write_reg $address 0x[format %X $value] $chan "$avmm"
# }

# proc etile_write_reg	{ addr_in_hex reg_value_in_hex chan avmm } {

	
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_LO
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_L1
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_L2
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_L3
	# global 	ip_sub_variant_option 

	
		# if {[string first nrz $ip_sub_variant_option] > -1 } {
		
			# if { $chan == 0 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex $reg_value_in_hex }
			# if { $chan == 1 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L1 $addr_in_hex $reg_value_in_hex }
			# if { $chan == 2 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex $reg_value_in_hex }
			# if { $chan == 3 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L3 $addr_in_hex $reg_value_in_hex }
		# } else {
		
			# if { $chan == 0 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex $reg_value_in_hex }
			# if { $chan == 1 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex $reg_value_in_hex }
		# }
	
# }

# proc etile_read_reg		{ addr_in_hex chan avmm {no_of_reg 1} {start 8} {stop 9}} {
	
	
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_LO
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_L1
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_L2
	# global 	BASE_ETILE_EHIPC3_100G_XCVR_L3
	# global 	ip_sub_variant_option 
		
	# if {[string first nrz $ip_sub_variant_option] > -1 } {
				
				# if { $chan == 0 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex ] }
				# if { $chan == 1 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L1 $addr_in_hex ] }
				# if { $chan == 2 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex ] }
				# if { $chan == 3 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L3 $addr_in_hex ] }
	# } else {
				
				# if { $chan == 0 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex ] }
				# if { $chan == 1 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex ] }
	# }
		# return $read_val
	
# }
proc proc_pkt_gen_random_gap {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_random_gap text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_random_gap text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		#dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		reg_write 0x1010 0x5
	} elseif {[string match [dashboard_get_property $dash pkt_gen_random_gap text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_random_gap text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		#dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x7
	}

}

proc proc_pkt_gen_no_gap {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_no_gap text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_no_gap text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		#dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		reg_write 0x1010 0x85
	} elseif {[string match [dashboard_get_property $dash pkt_gen_no_gap text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_no_gap text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		#dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x87
	}

}

proc proc_pkt_gen_fixed {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_fixed text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_fixed text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		#dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		set size [dashboard_get_property $dash pkt_byte_size_val text]
		set hex_size 0x[format %x $size]
		reg_write 0x1008 $hex_size
		set num [dashboard_get_property $dash pkt_num_val text]
		set hex_num 0x[format %x $num]
		reg_write 0x1009 $hex_num
		reg_write 0x1010 0x55
	} elseif {[string match [dashboard_get_property $dash pkt_gen_fixed text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_fixed text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		#dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x57
	}

}

proc proc_pkt_gen_incr {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_incr text] "Start Packet Generator"]} {
	dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		#dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		dashboard_set_property $dash pkt_gen_incr text "Stop Packet Generator"
		set begin_size [dashboard_get_property $dash pkt_byte_size_begin_val text]
		set begin_size_hex 0x[format %x $begin_size]
	
		set end_size [dashboard_get_property $dash pkt_byte_size_end_val text]
		set end_size_hex 0x[format %x $end_size]
		
		#reg_write 0x1008 $size
		set end_size_shift [ expr $end_size_hex << 16 ]
		set size [ expr $end_size_shift + $begin_size_hex ]
		reg_write 0x1008 $size
		set num [dashboard_get_property $dash pkt_incr_num_val text]
		set num_hex 0x[format %x $num]
		reg_write 0x1009 $num_hex
		reg_write 0x1010 0x65
	} elseif {[string match [dashboard_get_property $dash pkt_gen_incr text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_incr text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		#dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x67
	}

}

proc dashboard {} {

global dash
global BASE_ETILE_EHIPC3_100G
global ip_sub_variant_option
global anlt_enabled


	
	
			# widget_label 1 ical_recipe link "Step 1 - Click the drop-down to select a recipe and Click on Apply Button"
				# dashboard_set_property $dash ical_recipe foregroundColor blue
			# widget_label 1 mission_mode link "Step 2 - For Mission mode - Click on 'Link Initialization' button"
				# dashboard_set_property $dash mission_mode foregroundColor blue
			# widget_label 1 mission_mode link "                  - This performs Internal Serial Loopback (ILB) -> Initial Adaptation (iADP) -> Mission mode -> Initial Adaptation"
				# dashboard_set_property $dash mission_mode foregroundColor blue	
			# widget_label 1 serial_loop_back link	"           -  For Internal Serial Loop-back (ILB) -  a. Enable ILB check box. b. Click on iADP"
				# dashboard_set_property $dash serial_loop_back foregroundColor blue
	
	widget_checkBox 1 continuous_read_etile_ehipc3_100g etile_ehipc3_100g "Continuous Read All Registers" proc_continuous_read_etile_ehipc3_100g
	
		widget_group 1 tx_rx_status etile_ehipc3_100g 5 ""
			widget_label 1 txpcsready_etile_ehipc3_100g tx_rx_status "TX PCS Ready"
			widget_led 1 txpcsready_value_etile_ehipc3_100g tx_rx_status "" black 	
			widget_label 1 dummy_space tx_rx_status "         "
			widget_label 1 rxpcsaligned_etile_ehipc3_100g tx_rx_status "RX PCS Aligned"
			widget_led 1 rxpcsaligned_value_etile_ehipc3_100g tx_rx_status "" black	
		
	dashboard_add $dash allstatus_etile_ehipc3_100g tabbedGroup etile_ehipc3_100g
		
		
		widget_group 1 mac_pcs_status_etile_ehipc3_100g allstatus_etile_ehipc3_100g 1 "MAC & PCS"
		
			widget_group 1 reset_etile_ehipc3_100g mac_pcs_status_etile_ehipc3_100g 3 "Resets"
					widget_button 1 eio_sys_rst_etile_ehipc3_100g reset_etile_ehipc3_100g "Assert Full System Reset" proc_eio_sys_rst_etile_ehipc3_100g
						dashboard_set_property $dash eio_sys_rst_etile_ehipc3_100g toolTip "This resets TX MAC & PCS, RX MAC & PCS, PMA"
					widget_button 1 soft_txp_rst_etile_ehipc3_100g reset_etile_ehipc3_100g "Assert TX MAC & PCS Reset" proc_soft_txp_rst_etile_ehipc3_100g
					widget_button 1 soft_rxp_rst_etile_ehipc3_100g reset_etile_ehipc3_100g "Assert RX MAC & PCS Reset" proc_soft_rxp_rst_etile_ehipc3_100g
			
			widget_group 1 pcs_reset_status_etile_ehipc3_100g mac_pcs_status_etile_ehipc3_100g 2 ""
			
			widget_group 1 pcs_status_etile_ehipc3_100g pcs_reset_status_etile_ehipc3_100g 2 "PCS Status"
				
				widget_button 1 read_pcs_status_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "Read PCS Status" proc_read_pcs_status_etile_ehipc3_100g
				widget_label 1 dummy_space1 pcs_status_etile_ehipc3_100g ""	
				
				
								
				if {$ip_sub_variant_option == "25g_nrz"}  {
				
					#widget_group 1 lane_status_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 2 ""
					
					widget_label 1 txlocked_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "TX PMA Clock Locked"
					widget_led 1 txlocked_l0_etile_ehipc3_100g pcs_status_etile_ehipc3_100g ""  black
													
					widget_label 1 rxcdrplllocked_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "RX CDR Locked"
					widget_led 1 rxcdrplllocked_l0_etile_ehipc3_100g pcs_status_etile_ehipc3_100g ""  black
					
				
				
				} elseif {$ip_sub_variant_option == "10g_nrz"}  {
					
					#widget_group 1 lane_status_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 2 ""
					
					widget_label 1 txlocked_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "TX PMA Clock Locked"
					widget_led 1 txlocked_l0_etile_ehipc3_100g pcs_status_etile_ehipc3_100g ""  black
													
					widget_label 1 rxcdrplllocked_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "RX CDR Locked"
					widget_led 1 rxcdrplllocked_l0_etile_ehipc3_100g pcs_status_etile_ehipc3_100g ""  black
										
				}
				
				
				#widget_group 1 clock_lock_status_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 2 ""
				
					widget_label 1 txclk_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "TX Clock (KHz)"
					widget_textBox 1 txclk_value_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 0 "000000" 7 175
										
					widget_label 1 rxclk_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "RX Clock (KHz)"
					widget_textBox 1 rxclk_value_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 0 "000000" 7 175
					
					widget_label 1 frameerror_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "Frame Errors"
					widget_textBox 1 frameerror_value_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 0 "0x00000000" 7 175
					
					#widget_label 1 amlock_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "Alignment Marker Lock"
					#widget_led 1 amlock_value_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "" black
					
					widget_label 1 bercount_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "BER Count"
					widget_textBox 1 bercount_value_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 0 "0x00000000" 7 175
					
					widget_label 1 hiber_etile_ehipc3_100g pcs_status_etile_ehipc3_100g "Hi-BER"
					widget_textBox 1 hiber_value_etile_ehipc3_100g pcs_status_etile_ehipc3_100g 0 "Not Detected" 7 175
					
					
			widget_group 1 ical_status_lpbk_etile_ehipc3_100g_top pcs_reset_status_etile_ehipc3_100g 1 "Link Bring Up"
			
			#widget_group 1 link etile_ehipc3_100g 1 "Guidelines for Link bring-up"
				widget_label 1 ical_recipe ical_status_lpbk_etile_ehipc3_100g_top "Please Refer Help Tab for usage"
				dashboard_set_property $dash ical_recipe foregroundColor blue
				
					widget_group 1 ical_status_lpbk_etile_ehipc3_100g_1 ical_status_lpbk_etile_ehipc3_100g_top 2 "Step 1"
					
						if {$ip_sub_variant_option == "25g_nrz"} {
						widget_comboBoxonChange 1 ical_recipe_dropdown ical_status_lpbk_etile_ehipc3_100g_1 {"Default" "25G NRZ LR" "25G NRZ VSR"} proc_ical_recipe_dropdown
					} elseif {$ip_sub_variant_option == "10g_nrz"} {	
						widget_comboBoxonChange 1 ical_recipe_dropdown ical_status_lpbk_etile_ehipc3_100g_1 {"Default" "10G NRZ"} proc_ical_recipe_dropdown
					}	
															
					widget_button 1 ical_recipe_apply ical_status_lpbk_etile_ehipc3_100g_1 "Apply" proc_ical_recipe 
						dashboard_set_property $dash ical_recipe_apply enabled false
					
					widget_label 1 dummy_space1 ical_status_lpbk_etile_ehipc3_100g_1 "         "	
					
					widget_group 1 ical_status_lpbk_etile_ehipc3_100g_2 ical_status_lpbk_etile_ehipc3_100g_top 3 "Step 2"
					
					widget_button 1 imiss_lpbk_etile_ehipc3_100g ical_status_lpbk_etile_ehipc3_100g_2 "Link Initialization" proc_imiss_lpbk_etile_ehipc3_100g
						dashboard_set_property $dash ical_status_lpbk_etile_ehipc3_100g_2 toolTip "Internal Serial Loopback -> Initial Adaptation -> Mission mode -> Initial Adaptation"
						
					widget_checkBox 1 ilb_lpbk_etile_ehipc3_100g ical_status_lpbk_etile_ehipc3_100g_2 "ILB" proc_ilb_lpbk_etile_ehipc3_100g
					
					widget_button 1 iadt_lpbk_etile_ehipc3_100g ical_status_lpbk_etile_ehipc3_100g_2 "iADP" proc_iadp_lpbk_etile_ehipc3_100g
						dashboard_set_property $dash iadt_lpbk_etile_ehipc3_100g toolTip "Initial Adaptation"
					
					
						
					widget_led 1 ical_notif_etile_ehipc3_100g ical_status_lpbk_etile_ehipc3_100g_2 "---" black
					widget_label 1 dummy_space2 ical_status_lpbk_etile_ehipc3_100g_2 "         "	
			
			
			
			widget_group 1 mac_status_etile_ehipc3_100g mac_pcs_status_etile_ehipc3_100g 2 ""
				
				widget_group 1 txmac_status_etile_ehipc3_100g mac_status_etile_ehipc3_100g 2 "TX MAC Status"
					widget_button 1 read_txmac_status_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Read TX MAC Status" proc_read_txmac_status_etile_ehipc3_100g
					widget_label 1 blank_txmac_status_etile_ehipc3_100g txmac_status_etile_ehipc3_100g ""
					
					widget_label 1 force_remote_fault_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Force Remote Fault"
					widget_textBox 1 force_remote_fault_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Off" 7 250
						
					widget_label 1 disable_remote_fault_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Disable Remote Fault"
					widget_textBox 1 disable_remote_fault_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Off" 7 250
						
					widget_label 1 unidir_remote_link_fault_reporting_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Unidirectional Link Fault Reporting"
					widget_textBox 1 unidir_remote_link_fault_reporting_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Off" 7 250
						
					widget_label 1 link_fault_reporting_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Link Fault Reporting"
					widget_textBox 1 link_fault_reporting_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "On" 7 250
						
					widget_label 1 idle_col_rem_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "IPG Words removed per AM Period"
					widget_textBox 1 idle_col_rem_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "0x00000000" 7 250
						
					widget_label 1 max_tx_size_config_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Max TX Size Config"
					widget_textBox 1 max_tx_size_config_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "0x00000000" 7 250
						
					widget_label 1 en_saddr_insert_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Source Address Insertion"
					widget_textBox 1 en_saddr_insert_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Client provides Source Address" 7 250
					
					widget_label 1 saddrh_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Upper 2 bytes of Source Address"
					widget_textBox 1 saddrh_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "0x00000000" 7 250
					
					widget_label 1 saddrl_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "Lower 4 bytes of Source Address"
					widget_textBox 1 saddrl_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "0x00000000" 7 250
					
					widget_label 1 vlan_detection_tx_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "VLAN Detection for TX Stats"
					widget_textBox 1 vlan_detection_tx_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Disabled" 7 250
						
					widget_label 1 txcrc_covers_preamble_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "TX CRC over preamble"
					widget_textBox 1 txcrc_covers_preamble_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Off" 7 250
						
					widget_label 1 ipg_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "DIC Average Min IPG"
					widget_textBox 1 ipg_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "12 bytes" 7 250
						
					widget_label 1 en_pp_tx_etile_ehipc3_100g txmac_status_etile_ehipc3_100g "TX Preamble Passthrough"
					widget_textBox 1 en_pp_tx_text_etile_ehipc3_100g txmac_status_etile_ehipc3_100g 0 "Disabled" 7 250
		
				widget_group 1 rxmac_status_etile_ehipc3_100g mac_status_etile_ehipc3_100g 2 "RX MAC Status"
					widget_button 1 read_rxmac_status_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Read RX MAC Status" proc_read_rxmac_status_etile_ehipc3_100g
					widget_label 1 blank_rxmac_status_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g ""
					
					widget_label 1 max_rx_size_config_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "MAX RX Size Config"
					widget_textBox 1 max_rx_size_config_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "00000000" 7 300
						
					widget_label 1 mac_crc_config_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "RX CRC Forwarding"
					widget_textBox 1 mac_crc_config_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Remove CRC from RX frames" 7 300
						
					widget_label 1 remote_fault_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Remote Fault"
					dashboard_set_property $dash remote_fault_etile_ehipc3_100g foregroundColor black
					widget_textBox 1 remote_fault_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Not Detected" 7 300
						
					widget_label 1 local_fault_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Local Fault"
					dashboard_set_property $dash local_fault_etile_ehipc3_100g foregroundColor black
					widget_textBox 1 local_fault_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Not Detected" 7 300
						
					widget_label 1 remove_rx_pad_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Remove PADs from padded frames"
					widget_textBox 1 remove_rx_pad_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Off" 7 300
						
					widget_label 1 enforce_max_rx_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Enforce Maximum frame size on RX packets"
					widget_textBox 1 enforce_max_rx_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Ovesized frames are not altered" 7 300
						
					widget_label 1 preamble_check_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Strict Preamble Checking"
					widget_textBox 1 preamble_check_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Off" 7 300
						
					widget_label 1 sfd_check_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "SFD Checking"
					widget_textBox 1 sfd_check_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Off" 7 300
						
					widget_label 1 vlan_detection_rx_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "RX VLAN Detection"
					widget_textBox 1 vlan_detection_rx_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Enabled" 7 300
						
					widget_label 1 en_plen_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "Packet Length Checking"
					widget_textBox 1 en_plen_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "On" 7 300
						
					widget_label 1 rxcrc_covers_preamble_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "RX CRC over preamble"
					widget_textBox 1 rxcrc_covers_preamble_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "RX CRC calculated over Ethernet Frame" 7 300
						
					widget_label 1 en_pp_rx_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g "RX Preamble Passthrough"
					widget_textBox 1 en_pp_rx_text_etile_ehipc3_100g rxmac_status_etile_ehipc3_100g 0 "Disabled" 7 300
		
		widget_groupHeight 1 mac_and_pcs_status_dummygroup mac_pcs_status_etile_ehipc3_100g 1 "" 675
			#dashboard_set_property $dash mac_and_pcs_status_dummygroup preferredHeight 280
			#dashboard_set_property $dash $name preferredWidth $preferredWidth
		
		
		widget_group 1 mac_fec_stats_etile_ehipc3_100g_top allstatus_etile_ehipc3_100g 2 "Statistics"
		
		
		widget_group 1 mac_fec_stats_etile_ehipc3_100g mac_fec_stats_etile_ehipc3_100g_top 1 "MAC Statistics"
		
		widget_group 1 PKT_STATS_COUNT mac_fec_stats_etile_ehipc3_100g 1 ""
			packet_generator
		
		widget_group 1 mac_stats_etile_ehipc3_100g mac_fec_stats_etile_ehipc3_100g 2 ""
		
			
			widget_group 1 stats_counter_etile_ehipc3_100g mac_stats_etile_ehipc3_100g 2 ""			
			widget_group 1 mac_stats_etile_ehipc3_100g stats_counter_etile_ehipc3_100g 3 "TX & RX Statistics"
			
					widget_label 1 name_stats_count  mac_stats_etile_ehipc3_100g "Statistics Counters Names"
					widget_label 1 txmac_stats_ll  mac_stats_etile_ehipc3_100g "TX Statistics Counters"
					widget_label 1 rxmac_stats_ll  mac_stats_etile_ehipc3_100g "RX Statistics Counters"
				
					widget_label 1 read_statistics_ll  mac_stats_etile_ehipc3_100g ""				
					widget_button 1 read_tx_stats_etile_ehipc3_100g mac_stats_etile_ehipc3_100g "Read TX Statistics" proc_read_tx_stats_etile_ehipc3_100g
					widget_button 1 read_rx_stats_etile_ehipc3_100g mac_stats_etile_ehipc3_100g "Read RX Statistics" proc_read_rx_stats_etile_ehipc3_100g
					
					widget_label 1 read_statistics_ll  mac_stats_etile_ehipc3_100g ""				
					widget_button 1 reset_tx_stats_etile_ehipc3_100g mac_stats_etile_ehipc3_100g "Reset TX Statistics" proc_reset_tx_stats_etile_ehipc3_100g
					widget_button 1 reset_rx_stats_etile_ehipc3_100g mac_stats_etile_ehipc3_100g "Reset RX Statistics" proc_reset_rx_stats_etile_ehipc3_100g
												
					widget_label 1 cntr_tx_fragments mac_stats_etile_ehipc3_100g "Frames < 64 bytes with CRC error"
					widget_textBox 1 cntr_tx_fragments_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_fragments_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_jabbers mac_stats_etile_ehipc3_100g "Oversized frames with CRC error"
					widget_textBox 1 cntr_tx_jabbers_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_jabbers_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_fcs mac_stats_etile_ehipc3_100g "Frames of any size with a CRC error"
					widget_textBox 1 cntr_tx_fcs_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_fcs_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_fcs_err_okpkt mac_stats_etile_ehipc3_100g "Frames of any size with a CRC error on OK packet"
					widget_textBox 1 cntr_tx_fcs_err_okpkt_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_fcs_err_okpkt_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_data_err mac_stats_etile_ehipc3_100g "Multicast data frames with CRC error"
					widget_textBox 1 cntr_tx_mcast_data_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_data_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_data_err mac_stats_etile_ehipc3_100g "Broadcast data frames with CRC error"
					widget_textBox 1 cntr_tx_bcast_data_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_data_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_data_err mac_stats_etile_ehipc3_100g "Unicast data frames with CRC error"
					widget_textBox 1 cntr_tx_ucast_data_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_data_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_ctrl_err mac_stats_etile_ehipc3_100g "Multicast Control frames with CRC error"
					widget_textBox 1 cntr_tx_mcast_ctrl_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_ctrl_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_ctrl_err mac_stats_etile_ehipc3_100g "Broadcast Control frames with CRC error"
					widget_textBox 1 cntr_tx_bcast_ctrl_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_ctrl_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_ctrl_err mac_stats_etile_ehipc3_100g "Unicast Control frames with CRC error"
					widget_textBox 1 cntr_tx_ucast_ctrl_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_ctrl_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_pause_err mac_stats_etile_ehipc3_100g "Pause frame with CRC error"
					widget_textBox 1 cntr_tx_pause_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_pause_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_64b mac_stats_etile_ehipc3_100g "64 Byte Frames"
					widget_textBox 1 cntr_tx_64b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_64b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_65to127b mac_stats_etile_ehipc3_100g "65 - 127 Byte Frames"
					widget_textBox 1 cntr_tx_65to127b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_65to127b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_128to255b mac_stats_etile_ehipc3_100g "128 - 255 Byte Frames"
					widget_textBox 1 cntr_tx_128to255b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_128to255b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_256to511b mac_stats_etile_ehipc3_100g "256 - 511 Byte Frames"
					widget_textBox 1 cntr_tx_256to511b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_256to511b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_512to1023b mac_stats_etile_ehipc3_100g "512 - 1023 Byte Frames"
					widget_textBox 1 cntr_tx_512to1023b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_512to1023b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_1024to1518b mac_stats_etile_ehipc3_100g "1024 - 1518 Byte Frames"
					widget_textBox 1 cntr_tx_1024to1518b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_1024to1518b_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_1519tomaxb mac_stats_etile_ehipc3_100g "1519 - MAX Size Frames"
					widget_textBox 1 cntr_tx_1519tomaxb_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_1519tomaxb_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_oversize mac_stats_etile_ehipc3_100g "Oversize Frames (> MAX Size Frames)"
					widget_textBox 1 cntr_tx_oversize_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_oversize_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_data_ok mac_stats_etile_ehipc3_100g "Multicast data frames without error"
					widget_textBox 1 cntr_tx_mcast_data_ok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_data_ok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_data_ok mac_stats_etile_ehipc3_100g "Broadcast data frames without error"
					widget_textBox 1 cntr_tx_bcast_data_ok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_data_ok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_data_ok mac_stats_etile_ehipc3_100g "Unicast data frames without error"
					widget_textBox 1 cntr_tx_ucast_data_ok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_data_ok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_ctrl mac_stats_etile_ehipc3_100g "Multicast Control frames without error"
					widget_textBox 1 cntr_tx_mcast_ctrl_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_ctrl_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_ctrl mac_stats_etile_ehipc3_100g "Broadcast Control frames without error"
					widget_textBox 1 cntr_tx_bcast_ctrl_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_ctrl_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_ctrl mac_stats_etile_ehipc3_100g "Unicast Control frames without error"
					widget_textBox 1 cntr_tx_ucast_ctrl_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_ctrl_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_pause mac_stats_etile_ehipc3_100g "Pause frames without error"
					widget_textBox 1 cntr_tx_pause_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_pause_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_runt mac_stats_etile_ehipc3_100g "Frames with < 64 bytes and a CRC error"
					widget_textBox 1 cntr_tx_runt_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_runt_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_st mac_stats_etile_ehipc3_100g "Number of frame starts"
					widget_textBox 1 cntr_tx_st_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_st_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_lenerr mac_stats_etile_ehipc3_100g "Number of length error"
					widget_textBox 1 cntr_tx_lenerr_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_lenerr_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_pfc_err mac_stats_etile_ehipc3_100g "PFC frame with CRC error"
					widget_textBox 1 cntr_tx_pfc_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_pfc_err_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_pfc mac_stats_etile_ehipc3_100g "PFC frame without error"
					widget_textBox 1 cntr_tx_pfc_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_pfc_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_payloadoctetsok mac_stats_etile_ehipc3_100g "Payload bytes with no errors"
					widget_textBox 1 cntr_tx_payloadoctetsok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_payloadoctetsok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 txoctetsok mac_stats_etile_ehipc3_100g "Frame bytes with no errors"
					widget_textBox 1 txoctetsok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 rxoctetsok_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_malformed mac_stats_etile_ehipc3_100g "Malformed frames"
					widget_textBox 1 cntr_tx_malformed_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_malformed_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_dropped mac_stats_etile_ehipc3_100g "TX Frames that were dropped due to error"
					widget_textBox 1 cntr_tx_dropped_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_dropped_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
					widget_label 1 cntr_tx_badlt mac_stats_etile_ehipc3_100g "TX Frames with bad length/type field"
					widget_textBox 1 cntr_tx_badlt_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					widget_textBox 1 cntr_rx_badlt_d mac_stats_etile_ehipc3_100g 0 "0" 7 120
					
							
			
			
			

}

proc dashboard_etile_ehipc3_100g {} {

	global dash
	global anlt_enabled
	dashboard
	
	#etile_CEI_spec_transceiver_debug_gui_tab
	source S10_Etile_Transceiver_Debug_Tool_Quartus18p1_V1p0.tcl
	
	if { $anlt_enabled } {
			dashboard_etile_ehipc3_100g_kr4
	}
		
	help_tab	
	
	
}


proc help_tab {} {

	global dash

	widget_group 1  Help allstatus_etile_ehipc3_100g 1 "Help"		

		widget_group 1 instructions Help 1 "Link Bring Up Guidelines"
		
				# widget_label 1 kr_steps instructions "Steps to bring up the Link in Serial Loop-back"					
				# widget_label 1 instructions_2 instructions	"   1. Check ILB check box and click on iADP button in MAC & PCS tab"
					# dashboard_set_property $dash instructions_2 foregroundColor blue			
				# widget_label 1 instructions_2 instructions	"   2. Click on Continuous Read All registers or Read PCS Status. The link should be up"
					# dashboard_set_property $dash instructions_2 foregroundColor blue	
				
				# widget_label 1 kr_steps instructions "Steps to bring up the Link in Serial Loop-back when KR is Enabled"					
				# widget_label 1 select_ip_note instructions	"   1. Check Ignore Nonce check box in PMA tab"
					# dashboard_set_property $dash select_ip_note foregroundColor blue
				# widget_label 1 instructions_1 instructions	"   2. Click Reset sequencer button in PMA tab"
					# dashboard_set_property $dash instructions_1 foregroundColor blue
				# widget_label 1 instructions_2 instructions	"   3. Check ILB check box and click on iADP button in MAC & PCS tab"
					# dashboard_set_property $dash instructions_2 foregroundColor blue			
				# widget_label 1 instructions_2 instructions	"   4. Click on Continuous Read All registers or Read PCS Status. The link should be up"
					# dashboard_set_property $dash instructions_2 foregroundColor blue	
				# #widget_groupHeight 1 instructions_dummy instructions 1 "" 40		
				
			widget_label 1 reset_steps instructions "-> Release the reset by setting source 3:0 to 1110 in ISSP (Applicable to design example generated in 18.1.1 or prior) "					
				dashboard_set_property $dash reset_steps foregroundColor blue			
			
			widget_label 1 kr_steps instructions "if (KR is enabled) ("					
				dashboard_set_property $dash kr_steps foregroundColor blue			
				widget_label 1 instructions_2 instructions	"      if (Internal Serial Loop-back or External Loop-back) ("
					dashboard_set_property $dash instructions_2 foregroundColor blue			
				widget_label 1 select_ip_note instructions	"            1. Check Ignore Nonce check box in PMA tab"
					#dashboard_set_property $dash select_ip_note foregroundColor blue
				widget_label 1 instructions_1 instructions	"            2. Click Reset sequencer button in PMA tab"
				widget_label 1 instructions_1a instructions	"            if ( Internal Serial Loop-back) ("
					dashboard_set_property $dash instructions_1a foregroundColor blue
				widget_label 1 instructions_2 instructions	"                  3. Check ILB check box in MAC & PCS tab" 
				widget_label 1 instructions_1b instructions	"            )"
					dashboard_set_property $dash instructions_1b foregroundColor blue
				#widget_label 1 instructions_1 instructions	"            4. Click on iADP button in MAC & PCS tab"
				
					#dashboard_set_property $dash instructions_2 foregroundColor blue			
				#widget_label 1 instructions_2 instructions	"            4. Click on Continuous Read All registers or Read PCS Status. The link should be up"
				widget_label 1 instructions_2 instructions	"            4. Click on Continuous Read All registers or Read PCS Status"
					#dashboard_set_property $dash instructions_2 foregroundColor blue	
				widget_label 1 instructions_Mis_Kr instructions	"      ) elseif (Connect to Link Partner) ("
					dashboard_set_property $dash instructions_Mis_Kr foregroundColor blue
				widget_label 1 instructions_2 instructions	"            1. Click on Continuous Read All registers or Read PCS Status"
				widget_label 1 instructions_3 instructions	"      )"
					dashboard_set_property $dash instructions_3 foregroundColor blue
				
					#dashboard_set_property $dash instructions_2 foregroundColor blue
				widget_label 1 non_kr_steps instructions ") elseif (KR is disabled) ("					
					dashboard_set_property $dash non_kr_steps foregroundColor blue
							
					#dashboard_set_property $dash non_kr_steps foregroundColor blue	
				widget_label 1 non_kr_steps_2 instructions	"      if (Internal Serial Loop-back) ("
					dashboard_set_property $dash non_kr_steps_2 foregroundColor blue	
				#widget_label 1 non_kr_instructions_1a instructions	"            if ( Internal Serial Loop-back) ("
					#dashboard_set_property $dash non_kr_instructions_1a foregroundColor blue
				widget_label 1 non_kr_instructions_2 instructions	"             1. Check ILB check box in MAC & PCS tab" 
				widget_label 1 non_kr_steps_3 instructions "            	 2. Click on iADP"
				#widget_label 1 non_kr_instructions_1b instructions	"            )"
					#dashboard_set_property $dash non_kr_instructions_1b foregroundColor blue					
				
					#dashboard_set_property $dash instructions_2 foregroundColor blue
				widget_label 1 non_kr_steps_4 instructions "      ) elseif (Connect to Link Partner or External Loop-back) ("
					dashboard_set_property $dash non_kr_steps_4 foregroundColor blue	
				widget_label 1 non_kr_steps_1 instructions "             1. Click the drop-down to select a recipe and Click on Apply Button"		
				widget_label 1 non_kr_steps_5 instructions  "             2. Click on 'Link Initialization' button"
					#dashboard_set_property $dash instructions_2 foregroundColor 
				widget_label 1 instructions_3 instructions	"      )"
					dashboard_set_property $dash instructions_3 foregroundColor blue
				widget_label 1 instructions_2 instructions	"      3. Click on Continuous Read All registers or Read PCS Status"	
				widget_label 1 instructions_3 instructions	")"
					dashboard_set_property $dash instructions_3 foregroundColor blue
					# widget_label 1 ical_recipe link "Step 1 - Click the drop-down to select a recipe and Click on Apply Button"
				# dashboard_set_property $dash ical_recipe foregroundColor blue
			# widget_label 1 mission_mode link "Step 2 - For Mission mode - Click on 'Link Initialization' button"
				# dashboard_set_property $dash mission_mode foregroundColor blue
			# widget_label 1 mission_mode link "                  - This performs Internal Serial Loopback (ILB) -> Initial Adaptation (iADP) -> Mission mode -> Initial Adaptation"
				# dashboard_set_property $dash mission_mode foregroundColor blue	
			# widget_label 1 serial_loop_back link	"           -  For Internal Serial Loop-back (ILB) -  a. Enable ILB check box. b. Click on iADP"
				# dashboard_set_property $dash serial_loop_back foregroundColor blue
		widget_groupHeight 1 help_status_dummygroup Help 1 "" 975
}
proc dashboard_etile_ehipc3_100g_rsfec {} {

	global dash
	global corrected_cw0 
	global uncorrected_cw0
	global corrected_symbol0
	global corrected_bits_0_to_1_lane0
	global corrected_bits_1_to_0_lane0
	global corrected_symbols
	global rate
	global pattern
	global anlt_enabled

	dashboard 
	
	widget_group 1 fec_stats_etile_ehipc3_100g_top stats_counter_etile_ehipc3_100g 1 ""
		widget_group 1 fec_stats_etile_ehipc3_100g fec_stats_etile_ehipc3_100g_top 1 "FEC Statistics"
	
		widget_button 1 read_fec_stats fec_stats_etile_ehipc3_100g "Read FEC Statistics" proc_read_fec_stats
		
		widget_group 1 tx_fec_err_inj_top fec_stats_etile_ehipc3_100g 2 "TX - FEC Error Injection"
		
			widget_group 1 tx_fec_err_inj tx_fec_err_inj_top 4 ""
		
			
			
				widget_label 1 rate tx_fec_err_inj "Rate (0x00 - 0xFF)"
					dashboard_set_property $dash rate toolTip "Rate defines the frequency of error insertion. User input 'a' means total 'a' blocks to be corrupted for every 256 blocks (Each block in 66-bit wide)."
				widget_label 1 pattern tx_fec_err_inj "Pattern (0x00 - 0xFF)"
					dashboard_set_property $dash pattern toolTip "Once corrupted blocks are decided by 'Rate' field, 8 consecutive bits (out of 66) of each corrupted block are XOR'ed with pattern field."
				widget_label 1 blank1 tx_fec_err_inj ""
				widget_label 1 blank2 tx_fec_err_inj ""
				
				widget_textBox 1 rate tx_fec_err_inj 1 0x00 10 50
				widget_textBox 1 pattern tx_fec_err_inj 1 0x00 10 50
				widget_button 1 fec_inject_error tx_fec_err_inj "Inject Errors" inject_error
				widget_button 1 fec_inject_error_clear tx_fec_err_inj "Clear Injected Errors" inject_error_clear
					
				
				
			widget_groupWidth 1 tx_fec_err_inj_2 tx_fec_err_inj_top 1 "Inject Error Patterns" 125	
					widget_button 1 fec_preload_error tx_fec_err_inj_2 "Case 1" pre_load_error
				
				
		widget_group 1 rx_fec_err_stats fec_stats_etile_ehipc3_100g 1 "RX - FEC Statistics"
		
		widget_button 1 clear_fec_counters rx_fec_err_stats "Clear FEC Counters" clear_fec_counters
			
			widget_group 1 corrected_cw_group rx_fec_err_stats 2 ""
				widget_label 1 corrected_cw0_label corrected_cw_group "Corrected CodeWords"
				widget_textBox 1 corrected_cw0 corrected_cw_group 0 "[set corrected_cw0]" 10 125
				
			widget_group 1 uncorrected_cw_group rx_fec_err_stats 2 ""
				widget_label 1 uncorrected_cw0_label uncorrected_cw_group "UnCorrected CodeWords"
				widget_textBox 1 uncorrected_cw0 uncorrected_cw_group 0 "[set uncorrected_cw0]" 10 125

			#			
			widget_group 1 corrected_symbols_n_bits rx_fec_err_stats 2 ""
						
			widget_labelwidth 1 corrected_symbols corrected_symbols_n_bits "Corrected Symbols" 110
			widget_textBox 1 corrected_symbol corrected_symbols_n_bits 0 "[set corrected_symbol0]" 10 125
			
			
			widget_labelwidth 1 corrected_bits_0_to_1 corrected_symbols_n_bits "Corrected Bits 0_to_1" 110
			widget_textBox 1 corrected_bits_0_to_1 corrected_symbols_n_bits 0 "[set corrected_bits_0_to_1_lane0]" 10 125
			
			widget_labelwidth 1 corrected_bits_1_to_0 corrected_symbols_n_bits "Corrected Bits 1_to_0" 110
			widget_textBox 1 corrected_bits_1_to_0 corrected_symbols_n_bits 0 "[set corrected_bits_1_to_0_lane0]" 10 125
					
			#		
			# widget_group 1 corrected_symbol_group rx_fec_err_stats 2 "Corrected Symbols"
				# for {set i 0} {$i < 4} {incr i}	{
					# widget_label 1 lane_label$i corrected_symbol_group "lane[set i]"
					# widget_labelwidth 1 corrected_symbol$i corrected_symbol_group "[set corrected_symbol[set i]]" 100
				# }
			
			# widget_group 1 corrected_bits_0_to_1_group rx_fec_err_stats 2 "Corrected Bits_0_to_1"
				# for {set i 0} {$i < 4} {incr i}	{
					# widget_label 1 lane_label$i corrected_bits_0_to_1_group "lane[set i]"
					# widget_labelwidth 1 corrected_bits_0_to_1$i corrected_bits_0_to_1_group "[set corrected_bits_0_to_1_lane[set i]]" 100
				# }
				
			# widget_group 1 corrected_bits_1_to_0_group rx_fec_err_stats 2 "Corrected Bits_1_to_0"
				# for {set i 0} {$i < 4} {incr i}	{
					# widget_label 1 lane_label$i corrected_bits_1_to_0_group "lane[set i]"
					# widget_labelwidth 1 corrected_bits_1_to_0$i corrected_bits_1_to_0_group "[set corrected_bits_1_to_0_lane[set i]]" 100
				# }
								
			widget_group 1 corrected_symbols_group rx_fec_err_stats 2 ""
				widget_label 1 corrected_symbols_label corrected_symbols_group "Number of symbols corrected per codeword"
				widget_textBox 1 corrected_symbols_per_codeword corrected_symbols_group 0 "[set corrected_symbols]" 10 250
				
			widget_groupHeight 1 fec_stats_ll_dummy fec_stats_etile_ehipc3_100g 1 "" 625
		
		
		#etile_CEI_spec_transceiver_debug_gui_tab
		source S10_Etile_Transceiver_Debug_Tool_Quartus18p1_V1p0.tcl
		
		if { $anlt_enabled } {
			dashboard_etile_ehipc3_100g_kr4
			
			}
			
		help_tab
}

proc dashboard_etile_ehipc3_100g_kr4 {} {

	global dash
	global ip_sub_variant_option
	
	#widget_group 1  etile_pma_status_kr allstatus_etile_ehipc3_100g 1 "PMA"
	
	widget_group 1  kr4_status_etile_ehipc3_100g etile_pma_status_top_group 1 "KR4"
	
		widget_button 1 read_kr4_status kr4_status_etile_ehipc3_100g "Read KR4 Status" proc_read_kr4_status
				
				widget_group 1 kr4_dummy_1 kr4_status_etile_ehipc3_100g 2 ""
				
				#
				#Sequencer
				#
				widget_group 1 SEQ_LT_FEC_DATA kr4_dummy_1 1 "Sequencer"
				
				widget_group 1 SEQ SEQ_LT_FEC_DATA 3 "Sequencer"
					
					widget_button 1 reset_seq SEQ "Reset Sequencer"  proc_reset_seq
						dashboard_set_property $dash reset_seq toolTip "This button will disable serial loop back"
					widget_checkBox 1 disable_if_timer SEQ "Disable Link Fail Inhibit timer" proc_disable_if_timer
					widget_label 1 seq_blank_2 SEQ ""
					
		
					widget_label 1 seq_force SEQ "SEQ Force Mode"
					if {$ip_sub_variant_option == "10g_nrz"} {
					widget_comboBox 1 seq_force_mode SEQ {"No Force" "10GBase-R"}
					} else {
					widget_comboBox 1 seq_force_mode SEQ {"No Force" "25GBase-R"}
					}
					widget_button 1 seq_force SEQ "Force" proc_seq_force
				
				#
				# Link Training Parameters
				#
				widget_group 1 LT SEQ_LT_FEC_DATA 2 "Link Training"
				
					widget_label 1 lt_ena_title LT "LT Enable"
					widget_led 1 lt_ena_data LT ""  black
					
					widget_checkBox 1 lt_disable_max_timer LT "Disable Max Wait Timer" proc_disable_max_timer
					widget_label 1 lt_disable_max_timer_dummy LT ""
					
					widget_label 1 lt_receiver_trained_title LT "Receiver Trained"
					widget_led 1 lt_receiver_trained_data LT ""  black
					
					#widget_label 1 lt_training_frame_title LT "LT Frame Lock"
					#widget_led 1 lt_training_frame_data LT ""  black

				
				#Data
				widget_group 1 DATA SEQ_LT_FEC_DATA 2 "Data"
				
					widget_label 1 seq_link_ready_title DATA "SEQ Link Ready"
					widget_led 1 seq_link_ready_data DATA ""  black
					
					widget_label 1 seq_reconfig_title DATA "Sequencer Mode"
					widget_textBox 1 seq_reconfig_data DATA 0 "---" 10 200	
					
				widget_groupHeight 1 seq_lt_fec_data_dummy SEQ_LT_FEC_DATA 1 "" 20
				
				#
				# Auto Negotiation & FEC Parameters
				#
				widget_group 1 AN kr4_dummy_1 2 "Auto Negotiation"
				
					widget_label 1 an_ena_title AN "AN Enable"
					widget_led 1 an_ena_data AN ""  black
					
					widget_checkBox 1 ignore_nonce AN "Ignore Nonce" proc_ignore_nonce
					widget_label 1 in_blank_2 AN ""
					
					widget_label 1 an_page_received_title AN "AN Page Received"
					widget_led 1 an_page_received_data AN "" black
					
					widget_label 1 an_complete_title AN "AN Complete"
					widget_led 1 an_complete_data AN "" black
					
					widget_label 1 an_abi_title AN "Link Partner availability"
					widget_textBox 1 an_abi_data AN 0 "---" 10 200
					
					widget_label 1 an_ieee_title AN "IEEE Negotiated Port Type"
					widget_textBox 1 an_ieee_data AN 0 "---" 10 200
										
					widget_label 1 an_consortium_port_type_title AN "Consortium Negotiated Port Type"
					widget_textBox 1 an_consortium_port_type_data AN 0 "---" 10 200
						
					widget_label 1 an_link_partner_title AN "Link Partner Technology"
					widget_textBox 1 an_link_partner_data AN 0 "---" 100 200
					
					widget_label 1 an_link_partner_remote_title AN "Link Partner Remote Fault"
					dashboard_set_property $dash an_link_partner_remote_title foregroundColor black					
					widget_textBox 1 an_link_partner_remote_data AN 0 "" 10 200
					
					widget_label 1 an_link_partner_pause_title AN "Link Partner Pause"
					widget_textBox 1 an_link_partner_pause_data AN 0 "---" 10 200
					
					#FEC Properties
				
					widget_checkBox 1 fec_request_rsfec AN "Request RS-FEC" proc_request_rsfec
					widget_label 1 lt_disable_max_timer_dummy AN ""
					
					widget_checkBox 1 fec_negotitation_rsfec AN "Enable RS-FEC Negotiation" proc_rsfec_negotiate
					widget_label 1 lt_disable_max_timer_dummy AN ""
					
					# widget_label 1 an_rs_fec_neg_title AN "RS-FEC Negotiated"
					# widget_textBox 1 an_rs_fec_neg_data AN 0 "---" 10 125
					
					widget_label 1 an_link_partner_fec_title AN "Link Partner FEC ability"
					widget_textBox 1 an_link_partner_fec_data AN 0 "---" 10 200
					
					
			widget_groupHeight 1 kr4_status_etile_ehipc3_100g_dummy kr4_dummy_1 5 "" 1050
}

proc proc_create_dash {} {

global dash
global ip_sub_variant_option
global rs_enabled
global anlt_enabled
global rs_enabled

	widget_label 0 select_ip_option_note select_ip_option "Plotting link monitor user interface ... please wait!!"
	dashboard_set_property $dash select_ip_option_note foregroundColor red
	
	if {$ip_sub_variant_option == "25g_nrz"} {
		
		if {$rs_enabled == 1} {
			
			if {$anlt_enabled} {				
			widget_group 1 etile_ehipc3_100g ip_tab 1 "E-tile Hard IP For Ethernet - 25G - NRZ w/RSFEC w/AN & LT"
			} else {
			widget_group 1 etile_ehipc3_100g ip_tab 1 "E-tile Hard IP For Ethernet - 25G - NRZ w/RSFEC"
			}
			dashboard_etile_ehipc3_100g_rsfec
		} else {
			if {$anlt_enabled} {				
			widget_group 1 etile_ehipc3_100g ip_tab 1 "E-tile Hard IP For Ethernet - 25G - NRZ w/AN & LT"
			} else {
			widget_group 1 etile_ehipc3_100g ip_tab 1 "E-tile Hard IP For Ethernet - 25G - NRZ"
			}
			dashboard_etile_ehipc3_100g 
			
		}
		
	
	} elseif {$ip_sub_variant_option == "10g_nrz"} {
			
			if {$anlt_enabled} {				
			widget_group 1 etile_ehipc3_100g ip_tab 1 "E-tile Hard IP For Ethernet - 10G - NRZ w/AN & LT"
			} else {
			widget_group 1 etile_ehipc3_100g ip_tab 1 "E-tile Hard IP For Ethernet - 10G - NRZ"
			}
			dashboard_etile_ehipc3_100g 
		
	
	}
	
	widget_label 0 select_ip_option_note select_ip_option "Link monitor user interface ready to use!!"
	dashboard_set_property $dash select_ip_option_note foregroundColor blue
	
	
}
